#include <unistd.h>
#include <errno.h>
#include <math.h>
#include <fftw3.h>

void DOA_estims_all(cplxnum ***FB_ORIG,float *DOAs,float Fs,float micspacing, float c,int L_freq,int L); //Estimate DOA

//*********************************************************************
//void DOA_estims_all(cplxnum ***FB_ORIG,float Fs,float micspacing, float c,int L_freq,int L)
//DOA estimation for TWO SENSOR case
//*********************************************************************
void DOA_estims_all(cplxnum ***FB_ORIG,float *DOAs,float Fs,float micspacing, float c,int L_freq,int L)
  {
  int l,i,j,freq;
  cplxnum tmp1,Rxx[2][2],U[2][2],S[2][2]={{0, 0},{0, 0}};
  float mag,phase,PROD,ABS_SUM,Pxx[NUM_SPATIAL_SPEC];
  int N=NUM_SPATIAL_SPEC;
  int P=1; //Number of DOAs to be picked.
  int N_peaks; //Number of detected peaks
  int *PEAKS;
  double TMP;

  PEAKS=(int *)calloc(P,sizeof(int));

  
  //DOA estimation at each bin. 
  for(freq = 1; freq < (int)(L_freq/(2*micspacing)); freq++)
    {
    //Forming correlation matrix at each bin
    Rxx[0][0].re=0;
    Rxx[0][0].im=0;
    Rxx[0][1].re=0;
    Rxx[0][1].im=0;
    Rxx[1][1].re=0;
    Rxx[1][1].im=0;
    ABS_SUM=0;
    for(l = 0; l < L; l++)
      {
      PROD=((FB_ORIG[l][0][freq].re*FB_ORIG[l][0][freq].re)+FB_ORIG[l][0][freq].im*FB_ORIG[l][0][freq].im);
      Rxx[0][0].re+=PROD;
      ABS_SUM+=(float)sqrt((double) PROD);  //Magintude of singnals added up

      Rxx[1][1].re+=((FB_ORIG[l][1][freq].re*FB_ORIG[l][1][freq].re)+FB_ORIG[l][1][freq].im*FB_ORIG[l][1][freq].im);

      Rxx[0][1].re+=((FB_ORIG[l][0][freq].re*FB_ORIG[l][1][freq].re)+FB_ORIG[l][0][freq].im*FB_ORIG[l][1][freq].im);
      Rxx[0][1].im+=(-1*(FB_ORIG[l][0][freq].re*FB_ORIG[l][1][freq].im)+FB_ORIG[l][0][freq].im*FB_ORIG[l][1][freq].re);
      }
    Rxx[0][0].re=Rxx[0][0].re/L;
    Rxx[0][0].im=Rxx[0][0].im/L;
    Rxx[0][1].re=Rxx[0][1].re/L;
    Rxx[0][1].im=Rxx[0][1].im/L;
    Rxx[1][1].re=Rxx[1][1].re/L;
    Rxx[1][1].im=Rxx[1][1].im/L;
    Rxx[1][0].re=Rxx[0][1].re;
    Rxx[1][0].im=-1*Rxx[0][1].im;

    //Finding the eigen values
    //b^2-4ac
    tmp1.re=((Rxx[0][0].re+Rxx[1][1].re)*(Rxx[0][0].re+Rxx[1][1].re))-(4*(Rxx[0][0].re*Rxx[1][1].re-(Rxx[0][1].re*Rxx[1][0].re-Rxx[0][1].im*Rxx[1][0].im)));
    tmp1.im=4*(Rxx[0][1].re*Rxx[1][0].im+Rxx[0][1].im*Rxx[1][0].re);
    //(b^2-4ac)^0.5
    //magnitude phase
    mag=(float)sqrt((double)(tmp1.re*tmp1.re+tmp1.im*tmp1.im));
    phase=(float)atan((double)(tmp1.im/tmp1.re));
    //rooting
    tmp1.re=(float)sqrt((double)mag)*cos((double)phase/2);
    tmp1.im=(float)sqrt((double)mag)*sin((double)phase/2);
    S[0][0].re=((Rxx[0][0].re+Rxx[1][1].re) + tmp1.re)/2;
    S[1][1].re=((Rxx[0][0].re+Rxx[1][1].re)-tmp1.re)/2;
    S[0][0].im=tmp1.im/2;
    S[1][1].im=-1*tmp1.im/2;

    if((((S[0][0].re/S[1][1].re)>10)&&(ABS_SUM>(L_freq/2))))//If condition number is large enough the find eigen vectors and do music. Working conditionnumber (10).
      {
      //Finding the unit norm eigen vector 1
      U[0][0].im=0;
      U[1][0].re=-1*(Rxx[0][0].re-S[0][0].re)*Rxx[0][1].re/(Rxx[0][1].re*Rxx[0][1].re+Rxx[0][1].im*Rxx[0][1].im);
      U[1][0].im=(Rxx[0][0].re-S[0][0].re)*Rxx[0][1].im/(Rxx[0][1].re*Rxx[0][1].re+Rxx[0][1].im*Rxx[0][1].im);
      //Normalising the eigen vectors
      mag=(float)sqrt((double)(1+U[1][0].re*U[1][0].re+U[1][0].im*U[1][0].im));
      U[0][0].re=1/mag;
      U[1][0].re=U[1][0].re/mag;
      U[1][0].im=U[1][0].im/mag;
                  
      //Finding the unit norm eigen vector 2
      U[0][1].im=0;
      U[1][1].re=-1*(Rxx[0][0].re-S[1][1].re)*Rxx[0][1].re/(Rxx[0][1].re*Rxx[0][1].re+Rxx[0][1].im*Rxx[0][1].im);
      U[1][1].im=(Rxx[0][0].re-S[1][1].re)*Rxx[0][1].im/(Rxx[0][1].re*Rxx[0][1].re+Rxx[0][1].im*Rxx[0][1].im);
      //Normalising the eigen vectors
      mag=(float)sqrt((double)(1+U[1][1].re*U[1][1].re+U[1][1].im*U[1][1].im));
      U[0][1].re=1/mag;
      U[1][1].re=U[1][1].re/mag;
      U[1][1].im=U[1][1].im/mag;

      //MUSIC
      Pxx[0]=0;
      for(l=1;l<N;l++)
	Pxx[l]=1/(float)sqrt((double)((U[0][1].re+cos(2*PI*l/N)*U[1][1].re-sin(2*PI*l/N)*U[1][1].im)*(U[0][1].re+cos(2*PI*l/N)*U[1][1].re-sin(2*PI*l/N)*U[1][1].im)+((U[0][1].im+cos(2*PI*l/N)*U[1][1].im)+sin(2*PI*l/N)*U[1][1].re)*((U[0][1].im+cos(2*PI*l/N)*U[1][1].im)+sin(2*PI*l/N)*U[1][1].re)));
	//Pxx[l]=1/((U[0][0].re+cos(2*PI*l/N)*U[1][1].re+sin(2*PI*l/N)*U[1][1].im)*(U[0][0].re+cos(2*PI*l/N)*U[1][1].re+sin(2*PI*l/N)*U[1][1].im)+(U[0][0].im+cos(2*PI*l/N)*U[1][1].im+sin(2*PI*l/N)*U[1][1].re)*(U[0][0].im+cos(2*PI*l/N)*U[1][1].im+sin(2*PI*l/N)*U[1][1].re));
      //peak_pick_vec(PEAKS,Pxx,N,P);     //To be changed to peak_pick_win
      peak_pick_win(Pxx,N,P,PEAKS,&N_peaks);     //Seems to be working fine
      PEAKS[0]+=1;
      PEAKS[0]=-1*(PEAKS[0]*((PEAKS[0]<N/2)? 1:0)+((PEAKS[0]>N/2)? 1:0)*PEAKS[0]-N*((PEAKS[0]>N/2)? 1:0));
      TMP=(double) ((PEAKS[0]*L_freq)/(N*micspacing*(freq)));
   //   printf("\n TMP=%f",TMP);
      if ((TMP>=(-1)) && (TMP<=1))
        DOAs[freq]=180*acos(TMP)/PI;
      else if (TMP<-1)          //New addition on 19-10-03
        DOAs[freq]=179;		//New addition on 19-10-03
      else if (TMP>1)           //New addition on 19-10-03
        DOAs[freq]=1;		//New addition on 19-10-0
      }
    else
      {
      DOAs[freq]=0;
      }
    }
  free(PEAKS);
  PEAKS=NULL;
  }

