#include <unistd.h>
#include <errno.h>
#include <math.h>

void DOA_estims_atten(float *DOAs,float *SPEC1, float *SPEC2, float *DOA_AT_MAP, float DOA_end, int L_start, int L_end);

//*******************************************************************************************
//DOA estimation for TWO SENSOR case based on inter aural attenuation
//*******************************************************************************************
void DOA_estims_atten(float *DOAs,float *SPEC1, float *SPEC2, float *DOA_AT_MAP,  float DOA_end, int L_start, int L_end)
  {
  int n,m,freq;
  int N_peaks1, N_peaks2; //Number of detected peaks
  int *PEAKS1, *PEAKS2, *FLAG1, *FLAG2;
  double TMP;

  FLAG1=(int *)calloc(30,sizeof(int));    //To indicate if the PEAK got assignned
  FLAG2=(int *)calloc(30,sizeof(int));    //To indicate if the PEAK got assignned
  PEAKS1=(int *)calloc(30,sizeof(int));   //To store the peaks in the spectrum
  PEAKS2=(int *)calloc(30,sizeof(int));   //To store the peaks in the spectrum
  peak_pick_win(SPEC1,L_end,30,PEAKS1,&N_peaks1); 
  peak_pick_win(SPEC2,L_end,30,PEAKS2,&N_peaks2); 
 

 //DOA estimation at each peak . 
  for(n=0;n<N_peaks1;n++)
    {
    for(m=0;m<N_peaks2;m++)
      {
      if((PEAKS1[n]>=L_start)&&(PEAKS2[m]>=L_start) && (FLAG2[m]==0))
        {
        if(fabsf((float)(PEAKS1[n]-PEAKS2[m])) < 5 )
          {
          if((SPEC1[PEAKS1[n]]+SPEC2[PEAKS2[m]]) > 7)
            {
            FLAG1[n]=1;
	    FLAG2[m]=1;
            if (SPEC1[PEAKS1[n]]>=SPEC2[PEAKS2[m]])
              DOAs[PEAKS1[n]]=(90+((SPEC1[PEAKS1[n]]/SPEC2[PEAKS2[m]])-1)*(90-DOA_end)/(DOA_AT_MAP[PEAKS1[n]]-1));
            else
              DOAs[PEAKS2[m]]=(90-((SPEC2[PEAKS2[m]]/SPEC1[PEAKS1[n]])-1)*(90-DOA_end)/(DOA_AT_MAP[PEAKS2[m]]-1));
            break;
            }
          }
        }
      }
    }
  
         //Accounding for other prominent peaks
  for(n=0;n<N_peaks1;n++)
    if((FLAG1[n]!=1) && (SPEC1[PEAKS1[n]]>7))
      DOAs[PEAKS1[n]]=140;
  for(m=0;m<N_peaks2;m++)
    if((FLAG2[m]!=1) && (SPEC2[PEAKS2[m]]>7))
      DOAs[PEAKS2[m]]=40;

  for(freq=0;freq< L_end;freq++)
    {
    DOAs[freq]=(DOAs[freq]< 10) ? 0 : DOAs[freq] ;
    DOAs[freq]=(DOAs[freq]> 170) ? 140 : DOAs[freq];
    }
       

 //DOA estimation at each bin using . 
/*  
  for(freq = L_start; freq < L_end; freq++)
    {
    if((SPEC1[freq]+SPEC2[freq]) > 10)
      DOAs[freq]=(SPEC1[freq]>=SPEC2[freq]) ? (90+((SPEC1[freq]/SPEC2[freq])-1)*(90-DOA_end)/(DOA_AT_MAP[freq]-1)) : (90-((SPEC2[freq]/SPEC1[freq])-1)*(90-DOA_end)/(DOA_AT_MAP[freq]-1));
    else
      DOAs[freq]=0;
    DOAs[freq]=((DOAs[freq]> 10) && (DOAs[freq]< 170)) ? DOAs[freq] : 0;
    }*/
  }

