/*From matrix.c*/
/*Matrix defenition*/
typedef struct 
   {
      int     row;
      int     col;
      float** m;

    } matrix;

//Complex number
typedef struct 
   {  
   float re;
   float im;
   } cplxnum;

//Complex values matrix
typedef struct 
   {
      int     row;
      int     col;
      cplxnum**  val;
    } cmatrix;



/*Creating matrix*/
matrix creat_mtrx(int ROW,int COL);
cmatrix creat_cmtrx(int ROW,int COL);

/*Refroming complex matrix*/
cmatrix mtrx_to_cmtrx(matrix *mat,int ST_ROW,int ST_COL,int ROW,int COL);
/*Refroming complex matrix with L_pad colums zero padded*/
cmatrix zpad_cplx_chnl(matrix *mat,int ST_ROW,int ST_COL,int ROW,int COL,int ROW_pad, int COL_pad);

/*Freeing matrix*/
int free_mtrx(matrix *mat);
int free_cmtrx(cmatrix *mat);



/*From cssts.c*/
int  srch(float* set,int ln,float val);
int* sortmax(int* setln,int nsets);
matrix sortsets(matrix mat,int N);

/*From delest.c*/
matrix delestm(matrix SIGS);

/*From final.c*/
matrix final(matrix SIGS);

/*From listgen.c*/
matrix listgn(matrix LIST1,matrix ALL_DELAYS);

/*From lnkdly.c*/
/*listm lnkdly(matrix LIST1,matrix LIST,matrix SORs);*/

/*From lpc.c*/
void lpc(float data[], int n, int m, float *xms, float d[]);

/*From main.c*/
matrix rd(char fname[]);
void print_matrix(matrix mat);

/*From mpath.c*/
matrix  mpath( matrix SIGS,matrix ALL_DELAYS);

/*From recov.c*/
/*matrix recov(matrix ALL_DELAYS, listm LNK_DLY, matrix SIG_KEEP);*/

/*From util.c*/
void print(matrix mat);
float  absf(float num);
float  sumv(matrix mat);
matrix sum(matrix mat);
void   sort(float* x,int*,int N);
matrix sinc(matrix mat);
matrix mean(matrix mat);
matrix setdiff(matrix a,matrix b);
matrix intersect(matrix a,matrix b);
matrix flipud(matrix mat);
matrix fliprl(matrix mat);
matrix reshape(matrix mat,int M,int N);
matrix conv(matrix x,matrix h);
matrix corr(matrix x,matrix h);
matrix peakpick(matrix mat,int N);
matrix linspace(float first,float last, int N);
matrix max(matrix x,int col_row);
matrix max_abs(matrix x,int col_row);
//
////Pick P peak of vector Pxx of length L and store it in PEAKS
void peak_pick_vec(int* PEAKS,float* Y,int L,int P);

//Comparison function used by qsort()
int compare_floats(const float *a, const float *b);

//N point histogram of vals which is of length L_val
void mhist(float* vals,int N,int L_val,float* HIST_val, float* HIST_idx);

//To find the N point scaled histogram of L_vals in val and using scaling in L_vals of scals
void scale_hist(float* vals,float* scals,int N,int L_val,float* HIST_val, float* HIST_idx);

/*From whtn.c*/
/*matrix whtn(matrix SIGS,int N_mics,int N_lpc)*/
