#include <unistd.h>
#include <errno.h>
#include <math.h>
#include <fftw3.h>


void pitchdetect(float *SPEC1,float *SPEC2,int L_freq,int L_start,int L_end,float **PF_idx, int *PF_idxN1, int *PF_idxN2);

/*********************************
//Pitch detection algotithm
********************************/
void pitchdetect(float *SPEC1,float *SPEC2,int L_freq,int L_start,int L_end,float **PF_idx, int *PF_idxN1, int *PF_idxN2)
  {
  int N_pnts=1;     //N_pnts is the number of succesive harmonics to be checked.
  int N_deci=10;    //
  int FLG=0;
  int N_blks,m,blk,n,l,MAX_ID_PTCH,pks,ptc;
  float ptch_m,FB_O_tmp,n_chk,FUNDA_COST1_max=0,FUNDA_COST2_max=0,FUNDA_COST_tmp1,FUNDA_COST_tmp2,x;
  float *FUNDA_COST1,*FUNDA_COST2,*PEAKS;
  int *IDX_PTCH, *ID_PK_PTCH;

  *PF_idxN1=0;
  *PF_idxN2=0;
  N_blks=(int)floorf((float)(L_freq/2)/(float)L_end)-N_pnts;
  FUNDA_COST1=(float *)calloc(((L_end-L_start)*N_deci+L_start),sizeof(float));
  FUNDA_COST2=(float *)calloc(((L_end-L_start)*N_deci+L_start),sizeof(float));
  for(m=(L_start-1);m<((L_end-L_start)*N_deci+L_start);m++)
    {
    ptch_m=((float)(m-L_start+1))/((float)N_deci)+(float)L_start;
    for(blk=0;blk<N_blks;blk++)
      {
      FUNDA_COST_tmp1=1;
      FUNDA_COST_tmp2=1;
      n_chk=((blk+1)*ptch_m-1);
      while(n_chk<((blk+1+N_pnts)*ptch_m))
	{
	/*printf("m=%d,\t blk=%d,\t n_chk=%f\n",m,blk,n_chk);*/
        FUNDA_COST_tmp1*=SPEC1[(int)rint(n_chk)];
        FUNDA_COST_tmp2*=SPEC2[(int)rint(n_chk)];
        n_chk+=ptch_m;
	}
      if(FUNDA_COST_tmp1>FUNDA_COST1[m])
        FUNDA_COST1[m]=FUNDA_COST_tmp1;
      if(FUNDA_COST_tmp2>FUNDA_COST2[m])
        FUNDA_COST2[m]=FUNDA_COST_tmp2;
      }
    if(FUNDA_COST1[m]>FUNDA_COST1_max)
      FUNDA_COST1_max=FUNDA_COST1[m];
    if(FUNDA_COST2[m]>FUNDA_COST2_max)
      FUNDA_COST2_max=FUNDA_COST2[m];
    }
  FUNDA_COST1_max*=0.3;   //Scaling to half for saving multiplication in later use.
  FUNDA_COST2_max*=0.3;   //Scaling to half for saving multiplication in later use.
  for(m=(L_start-1);m<((L_end-L_start)*N_deci+L_start);m++)
    {
    FUNDA_COST1[m]=((FUNDA_COST1[m]>FUNDA_COST1_max)? FUNDA_COST1[m]:0 );   //Thresholding for appreciable peaks, mic1.
    FUNDA_COST2[m]=((FUNDA_COST2[m]>FUNDA_COST2_max)? FUNDA_COST2[m]:0 );   //Thresholding for appreciable peaks, mic2.
    }
  ID_PK_PTCH=(int *)calloc(30,sizeof(int));  //Allocating space for Index of the peaks from peak_pick_win
  
    //Pitch for mic output 1.
  peak_pick_win(FUNDA_COST1,((L_end-L_start)*N_deci+L_start),30,ID_PK_PTCH,&MAX_ID_PTCH); //Picking the peaks in the detection function
  PEAKS=(float *)calloc(MAX_ID_PTCH,sizeof(float));  //For storing peak values
  if(MAX_ID_PTCH>0)
    {
    IDX_PTCH=(int *)calloc(MAX_ID_PTCH,sizeof(int));
    for(m=0;m<MAX_ID_PTCH;m++)     //Creating the array of peak values
      {
      PEAKS[m]=(float)ID_PK_PTCH[m];
      }
    sort(PEAKS, IDX_PTCH, MAX_ID_PTCH);    //Sorting the peaks 
    for(pks=0;pks<(MAX_ID_PTCH-1);pks++)
      for(m=pks+1;m<MAX_ID_PTCH;m++)
	if(PEAKS[pks] != 0)
	  {
	  x=rint(((PEAKS[m]-(float)L_start)/(float)N_deci+(float)L_start)/((PEAKS[pks]-(float)L_start)/(float)N_deci+(float)L_start));
	  if(fabs(x*((PEAKS[pks]-(float)L_start)/(float)N_deci+(float)L_start)-((PEAKS[m]-(float)L_start)/(float)N_deci+(float)L_start))<=3)
	    if(FUNDA_COST1[(int)PEAKS[pks]] > 1.1*FUNDA_COST1[(int)PEAKS[m]])
	      PEAKS[m]=PEAKS[pks];
	    else
	      PEAKS[pks]=PEAKS[m];
	  }
    PF_idx[0]=(float *)calloc(MAX_ID_PTCH,sizeof(float));
    //Making set difference and storing
    ptc=0;
    for(pks=0;pks<(MAX_ID_PTCH-1);pks++)
      {
      if(PEAKS[pks]>0)
	{
	if(ptc==0)
	  {
	  PF_idx[0][0]=(float)(PEAKS[pks]-L_start)/(float)N_deci+L_start;
          ptc++;
	  FLG=1;
	  }
        else
	  {
          for(m=0;m<ptc;m++)
	    {
	    if(fabsf(((float)(PEAKS[pks]-L_start)/(float)N_deci+L_start)-PF_idx[0][m])<0.1)
	      {
	      FLG=1;
              break;
	      }
	    }
	  }
	}
      else
	{
	FLG=1;
	}
      if(FLG==0)
	{
        PF_idx[0][ptc]=(float)(PEAKS[pks]-L_start)/(float)N_deci+L_start;
	ptc++;
	}
      FLG=0;
      }
    *PF_idxN1=ptc;
    free(IDX_PTCH);
    IDX_PTCH=NULL;
    free(PEAKS);
    PEAKS=NULL;
    }

    //Pitch for mic output 2.
  peak_pick_win(FUNDA_COST2,((L_end-L_start)*N_deci+L_start),30,ID_PK_PTCH,&MAX_ID_PTCH); //Picking the peaks in the detection function
  PEAKS=(float *)calloc(MAX_ID_PTCH,sizeof(float));  //For storing peak values
  if(MAX_ID_PTCH>0)
    {
    for(m=0;m<MAX_ID_PTCH;m++)     //Creating the array of peak values
      PEAKS[m]=(float)ID_PK_PTCH[m];
    IDX_PTCH=(int *)calloc(MAX_ID_PTCH,sizeof(int));
    sort(PEAKS, IDX_PTCH, MAX_ID_PTCH);    //Sorting the peaks 
    for(pks=0;pks<(MAX_ID_PTCH-1);pks++)
      for(m=pks+1;m<MAX_ID_PTCH;m++)
	if(PEAKS[pks] != 0)
	  {
	  x=rint(((PEAKS[m]-(float)L_start)/(float)N_deci+(float)L_start)/((PEAKS[pks]-(float)L_start)/(float)N_deci+(float)L_start));
	  if(fabs(x*((PEAKS[pks]-(float)L_start)/(float)N_deci+(float)L_start)-((PEAKS[m]-(float)L_start)/(float)N_deci+(float)L_start))<=3)
	    if(FUNDA_COST2[(int)PEAKS[pks]] > 1.1*FUNDA_COST2[(int)PEAKS[m]])
	      PEAKS[m]=PEAKS[pks];
	    else
	      PEAKS[pks]=PEAKS[m];
	  }
    PF_idx[1]=(float *)calloc(MAX_ID_PTCH,sizeof(float));
    //Making set difference and storing
    ptc=0;
    for(pks=0;pks<(MAX_ID_PTCH-1);pks++)
      {
      if(PEAKS[pks]>0)
	{
	if(ptc==0)
	  {
	  PF_idx[1][0]=(float)(PEAKS[pks]-L_start)/(float)N_deci+ (float)L_start;
          ptc++;
	  FLG=1;
	  }
        else
	  {
          for(m=0;m<ptc;m++)
	    {
	    if(fabsf(((float)(PEAKS[pks]-L_start)/(float)N_deci+(float)L_start)-PF_idx[1][m])<0.1)
	      {
	      FLG=1;
              break;
	      }
	    }
	  }
	}
      else
	{
	FLG=1;
	}
      if(FLG==0)
	{
        PF_idx[1][ptc]=(float)(PEAKS[pks]-L_start)/(float)N_deci+(float)L_start;
	ptc++;
	}
      FLG=0;
      }
    *PF_idxN2=ptc;
    free(IDX_PTCH);
    IDX_PTCH=NULL;
    free(PEAKS);
    PEAKS=NULL;
    }
  free(ID_PK_PTCH);
  free(FUNDA_COST1);
  free(FUNDA_COST2);
  }
