#include "numeric.h"
               //The signal data structure.
typedef struct
   {
      char    *file_name;        //File name to which the signal being processed is going to be saved
      int     file_name_set;     //1 if File name is set else 0
      int     n_channels;        //Number of channels 
      int     n_bytes;           //Number of bytes. Default is 2
      float   fs;               //Sampling rate being used at present
      float   fs_orig;           //Original sampling rate.
      matrix  channels;          //Where signal is stored.
      float   start_display1;   /*Time point from which display started*/
      float   end_display1;     /*Time point at which display ended*/
      float   start_display2;   /*Time point from which display started*/
      float   end_display2;     /*Time point at which display ended*/
    } signal;       


typedef struct
   {
      float   *sig;   //Has the signals
      int     L_src;  //Length of source signal after initialising.
      int     L_init;  //Index at which  source signal initialized.
      float   DOA;     //DOA of the source
      int     DOA_SET; //=1 when DOA is set
      float   PF;      //Has the pitch frequency of the source
      int     PF_SET;  //=1 when PF is set
      int     WT;      //Weighting for the source
      int     WTDOA;  //Weight for DOA of the source.
    } source;

#define NUM_SPATIAL_SPEC 1024 // NUM_SPATIAL_SPEC point spatial spectrum for DOA estimation
#define PI 3.14159265358979
#define SOURCE_NUM 8          //Maximum number of sources to be considered 
