#include <forms.h>
#include <flimage.h>
#include "scope.h"


FL_IMAGE *curr_image_left;   //Image structure for the left scope
FL_IMAGE *curr_image_right;  //Image structure for the right scope

/*** callbacks and freeobj handles for form scope ***/
void right_input_scope_cb(FL_OBJECT *ob, long data)
  {
  int ptr;  //Argument required by thread!! Not used
  extern FD_scope *fd_scope;
  extern SCOPE_flags scope_button_flag;
 
  fl_hide_object(fd_scope->right_plot_canvas);
  fl_show_object(fd_scope->right_xyplot);
  pthread_t thread_right_waveform_plot;   //Thread
  pthread_create(&thread_right_waveform_plot,NULL,right_waveform_scope_plot, (void *) &ptr); //Starting the thread
}

void left_right_plot_scope_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void right_specgram_scope_cb(FL_OBJECT *ob, long data)
{
  int ptr;  //Argument required by thread!! Not used
  extern FD_scope *fd_scope;
  extern SCOPE_flags scope_button_flag;
  extern FL_IMAGE *curr_image_right;
  pthread_t thread_right_specgram_plot;   //Thread

  
		  //Creating the image
  curr_image_right->type=FL_IMAGE_CI;   //Colour indexed image
  curr_image_right->w=256;  //Number of Columns
  curr_image_right->h=256;  //Number of Rows
  curr_image_right->wx=16;  //Origin in canvas
  curr_image_right->wy=16;  //Origin in canvas
  curr_image_right->map_len=256;  //Number of points in colour map
  flimage_getmem(curr_image_right);    //Allocating space for image data
 // curr_image_right->double_buffer = 1;   //Enabling double buffer for this image

  fl_hide_object(fd_scope->right_xyplot);
  fl_show_object(fd_scope->right_plot_canvas);
  pthread_create(&thread_right_specgram_plot,NULL,right_specgram_scope_plot, (void *) &ptr); //Starting the thread
}

void left_input_scope_cb(FL_OBJECT *ob, long data)
{
  int ptr;  //Argument required by thread!! Not used
  extern FD_scope *fd_scope;
  extern SCOPE_flags scope_button_flag;
 
  fl_hide_object(fd_scope->left_plot_canvas);
  fl_show_object(fd_scope->left_xyplot);
  pthread_t thread_left_waveform_plot;   //Thread
  pthread_create(&thread_left_waveform_plot,NULL,left_waveform_scope_plot, (void *) &ptr); //Starting the thread
}


void left_specgram_scope_cb(FL_OBJECT *ob, long data)
{
  int ptr;  //Argument required by thread!! Not used
  extern FD_scope *fd_scope;
  extern SCOPE_flags scope_button_flag;
  extern FL_IMAGE *curr_image_left;
  pthread_t thread_left_specgram_plot;   //Thread

  
		  //Creating the image
  curr_image_left->type=FL_IMAGE_CI;   //Colour indexed image
  curr_image_left->w=256;  //Number of Columns
  curr_image_left->h=256;  //Number of Rows
  curr_image_left->wx=16;  //Origin in canvas
  curr_image_left->wy=16;  //Origin in canvas
  curr_image_left->map_len=256;  //Number of points in colour map
  flimage_getmem(curr_image_left);    //Allocating space for image data
 // curr_image_left->double_buffer = 1;   //Enabling double buffer for this image

  fl_hide_object(fd_scope->left_xyplot);
  fl_show_object(fd_scope->left_plot_canvas);
  pthread_create(&thread_left_specgram_plot,NULL,left_specgram_scope_plot, (void *) &ptr); //Starting the thread
}

void left_plot_canvas_cb(FL_OBJECT *ob, long data)
{
}

void right_plot_canvas_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}



void close_scope_cb(FL_OBJECT *ob, long data)
{
 int n;
 extern FD_scope *fd_scope;
 clear_scope_form(fd_scope->scope,&n);
  /* fill-in code for callback */
}



