/*******************************************************
* Has all the functions required 
* for controlling and ploting in the left display of 
* the SCOPE. 
********************************************************/

/* Include this header file to use functions from libsndfile. */
#include <sndfile.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <errno.h>
#include <math.h>
#include <string.h>
/*#include <gsl/gsl_linalg.h>*/
#include "source_display.h"


#define f_0 900.0
#define AUDIO "/dev/dsp"


#define f_0 900.0
#define AUDIO "/dev/dsp"                                                        

/*    This will be the length of the buffer used to hold.frames while
**    we process them.
*/
#define    BUFFER_LEN      1024                  //(VARIABLE)

/* libsndfile can handle more than 6 channels but we'll restrict it to 6. */
#define    MAX_CHANNELS    2                  //(VARIABLE)


void left_specgram_scope_plot(void *ptr)
  {
  int row,col,i;
  int r,g,b;
  extern FL_IMAGE *curr_image_left;
  extern SCOPE_flags scope_button_flag;        //Flags to be set and unset

  if (scope_button_flag.left_specgram_set==1) //If the button is toggled then off it.
    {
    scope_button_flag.left_specgram_set=0;
    scope_button_flag.left_specgram_set_ack=1;
    return;
    }
  scope_button_flag.left_right_set=0;          //Unseting left_right_plot flag
  scope_button_flag.left_waveform_set=0;           //Unseting left_waveform_flag
  while((scope_button_flag.left_right_set_ack != 1)&&(scope_button_flag.left_waveform_set_ack != 1)) 
    { //For ack from other threads
    //printf("\n I am waiting in specgram for ack\n");
    }
  scope_button_flag.left_specgram_set=1;       //Setting that this thread is active
  scope_button_flag.left_specgram_set_ack=0;

  int TOGL=0;

  for(i=0;i<curr_image_left->map_len;i++)  //Creating colourmap
    {
    curr_image_left->red_lut[i]=(i<128) ? (128-i):0;   
    curr_image_left->blue_lut[i]=(i>=128) ? (i-128):0;   
    curr_image_left->green_lut[i]=128-(curr_image_left->red_lut[i]+curr_image_left->blue_lut[i]);   
    } 
 
  //printf("\n In the second display of image \n");
  while(scope_button_flag.left_specgram_set==1)              
    {
    if((TOGL==0) && (curr_image_left->modified==0))
      {
      TOGL=1;
      for(row=0;row<curr_image_left->h;row++)
        for(col=0;col<curr_image_left->h;col++)
          curr_image_left->ci[row][col]=row; 
      curr_image_left->modified=1;
    /*curr_image_left = flimage_load("SAA.xpm");*/
      }
    else 
      if(curr_image_left->modified==0)
        {
        TOGL=0;
        for(i=0;i<curr_image_left->map_len;i++)  //Creating colourmap
          {
          curr_image_left->red_lut[i]=(i<128) ? (128-i):0;   
          curr_image_left->blue_lut[i]=(i>=128) ? (i-128):0;   
          curr_image_left->green_lut[i]=128-(curr_image_left->red_lut[i]+curr_image_left->blue_lut[i]);   
          } 
        for(row=0;row<curr_image_left->h;row++)
          for(col=0;col<curr_image_left->h;col++)
            curr_image_left->ci[row][col]=256-row; 
        curr_image_left->modified=1;
    /*curr_image_left = flimage_load("SAA.xpm");*/
        }
    }
 
  scope_button_flag.left_specgram_set_ack=1;
  }


void left_waveform_scope_plot(void *ptr)
  {
  extern SCOPE_flags scope_button_flag;        //Flags to be set and unset

  if (scope_button_flag.left_waveform_set==1) //If the button is toggled then off it.
    {
    scope_button_flag.left_waveform_set=0;
    scope_button_flag.left_waveform_set_ack=1;
    //printf("\n I am quiting \n");
    return;
    }
  scope_button_flag.left_right_set=0;          //Unseting left_right_plot flag
  scope_button_flag.left_specgram_set=0;           //Unseting left_plot_flag
  while((scope_button_flag.left_right_set_ack != 1)&&(scope_button_flag.left_specgram_set_ack != 1)) 
    { //For ack from other threads
    //printf("\n I am waiting in waveform for ack\n");
    }
  scope_button_flag.left_waveform_set=1;       //Setting that this thread is active
  scope_button_flag.left_waveform_set_ack=0;
 
  //printf("\n I am here \n");
  
  while(scope_button_flag.left_waveform_set==1)              
    {
    }
  scope_button_flag.left_waveform_set_ack=1;
  }

