/*******************************************************
* Has all the functions required 
* for getting data from sound card for ploting  the display of 
* the SCOPE. 
********************************************************/

/* Include this header file to use functions from libsndfile. */
#include <sndfile.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <errno.h>
#include <math.h>
#include <string.h>
/*#include <gsl/gsl_linalg.h>*/
#include "source_display.h"


#define f_0 900.0
#define AUDIO "/dev/dsp"


#define f_0 900.0
#define AUDIO "/dev/dsp"                                                        

/*    This will be the length of the buffer used to hold.frames while
**    we process them.
*/
#define    BUFFER_LEN      1024                  //(VARIABLE)

/* libsndfile can handle more than 6 channels but we'll restrict it to 6. */
#define    MAX_CHANNELS    2                  //(VARIABLE)


void scope_sigrec(void *ptr)
  {
  extern SCOPE_flags scope_button_flag;        //Flags to be set and unset
  int setting = 0x000C000D; // 12 fragments size 8kb
  int format = AFMT_S16_LE;
  int rate;
  unsigned char *audio_buffer;
  int audio_fd,abuf_size,frag_size,mixer_fd;
  int stereo,n_bytes;     /* chnsl=1 for mono, 2 for stereo */
  int count,count_prev,l,c,len,i,n,cnt=0,cnt_samples;
  int mask;                     //Mask for mixer control

    /*unsigned char audio_buffer[BUF_SIZE];*/
  audio_buf_info info;          //The parameters of buffering
  abuf_size=4096;
  stereo=1;			//Setting recording to be stereo.
  rate=8000;			//Setting sampling frequency to be 8000 Hz. Can be changed later
  format=AFMT_S16_LE;		//Setting to 16 bit format.
  if((audio_fd = open("/dev/dsp",O_RDONLY, 0)) == -1)
    {                               // Opening device failed
    perror("/dev/dsp");
    }

  if( ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format) == -1 )
    {
    perror("ioctl set fragment");
    }
  if (ioctl(audio_fd, SNDCTL_DSP_STEREO, &stereo)==-1)
    { /* Fatal error */
    perror("SNDCTL_DSP_STEREO");
    }
  if( ioctl(audio_fd,SNDCTL_DSP_SPEED,&rate) == -1 )
    {
    perror("ioctl sample rate");
    }
  ioctl (audio_fd, SNDCTL_DSP_GETBLKSIZE, &abuf_size);
  if(abuf_size < 1024 || abuf_size > (2*65536))
    {
    if (abuf_size == -1)
      perror (AUDIO);
    else
      fprintf (stderr, "Invalid audio buffers size %d\n", abuf_size);
    }

  audio_buffer = malloc(abuf_size);
  left_scope_data=(float *)calloc(abuf_size/4,sizeof(float));
  left_x=(float *)calloc(abuf_size/4,sizeof(float));
  right_scope_data=(float *)calloc(abuf_size/4,sizeof(float));
  right_x=(float *)calloc(abuf_size/4,sizeof(float));

  for(n=0;n<abuf_size/4;n++)
    left_x[n]=(float)n/(float)rate;
  for(n=0;n<abuf_size/4;n++)
    right_x[n]=(float)n/(float)rate;
  while(scope_button_flag.onoff==1)              
    {
    //printf("\n Still running \n");
    if((len = read(audio_fd, audio_buffer, abuf_size)) > 0)
      {
      for(n=0;n<abuf_size/4-4;n++)
        {
        *(left_scope_data+n)=((float)(short)(*(audio_buffer+4*n) + 256*(*(audio_buffer+4*n+1))))/32768;
        *(right_scope_data+n)=((float)(short)(*(audio_buffer+4*n+2) + 256*(*(audio_buffer+4*n+3))))/32768;
        }
      } 
    }
  free(audio_buffer);
  free(left_scope_data);
  free(right_scope_data);
  free(left_x);
  free(right_x);
  close(audio_fd);
  }

