/*******************************************************
* Has all the functions required 
* for controlling and ploting in the SCOPE. Like the 
* X-channel, Y-Channel plots, X_Y plots, spectrograms
* of the various channels.
* for SAA. 
********************************************************/
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <errno.h>
#include <math.h>
/*#include <gsl/gsl_linalg.h>*/
#include <forms.h>
#include <flimage.h>
#include <pthread.h>
#include "scope.h"


//FUntion protypes
int chk_scope();
int scope_plot_initialise();  //Initialise signal plot
int clear_scope_form(FL_FORM *closing_form, void *n);  //To close the scope form without destructing the parent


float *left_scope_data, *left_x, *right_scope_data, *right_x;
FL_IMAGE *curr_image_left;   //Image structure for the left scope
FL_IMAGE *curr_image_right;  //Image structure for the right scope
int tid;                    //Timeout function variable
               //Functions for handling the refresh and movement        
static int expose_handle_left(FL_OBJECT *ob, Window win, int w, int h, XEvent *xev, void *data)
  {
  if(curr_image_left)
    flimage_display(curr_image_left, win);
  return 0;
  }

static int motion_handle_left(FL_OBJECT *ob, Window win, int w, int h, XEvent *xev, void *data)
  {
  if(!curr_image_left)
    return 0;
  if(1)
    {
  /*           fprintf(stderr,"X=%d Y=%d\n", xev->xmotion.x, xev->xmotion.y); */
    }
  }

static int expose_handle_right(FL_OBJECT *ob, Window win, int w, int h, XEvent *xev, void *data)
  {
  if(curr_image_right)
    flimage_display(curr_image_right, win);
  return 0;
  }

static int motion_handle_right(FL_OBJECT *ob, Window win, int w, int h, XEvent *xev, void *data)
  {
  if(!curr_image_right)
    return 0;
  if(1)
    {
  /*           fprintf(stderr,"X=%d Y=%d\n", xev->xmotion.x, xev->xmotion.y); */
    }
  }


//Funtions
/*************************************************
 * For displaying the plots on the scope. Starting
 * the form with that display
 ************************************************/
FD_scope *fd_scope;     //Global

int scope_plot_initialise()
  {
  extern int tid;
  Pixmap icon;
  unsigned width[0],height[0],hotx[0],hoty[0];
  extern FD_scope *fd_scope;
  extern FL_IMAGE *curr_image_left;
  extern SCOPE_flags scope_button_flag;   //Flags to be set and unset
  static FLIMAGE_SETUP setup;
  int ptr;  //Argument required by thread!! Not used

#if STUPID_WM
  int vmode;
#endif

  
  if (fd_scope)
    return; 
      //Flags for the buttons on the scope form
  scope_button_flag.left_waveform_set=0;
  scope_button_flag.right_waveform_set=0;
  scope_button_flag.left_right_set=0;
  scope_button_flag.left_specgram_set=0;
  scope_button_flag.right_specgram_set=0;
  scope_button_flag.left_waveform_set_ack=1;
  scope_button_flag.right_waveform_set_ack=1;
  scope_button_flag.left_right_set_ack=1;
  scope_button_flag.left_specgram_set_ack=1;
  scope_button_flag.right_specgram_set_ack=1;
 
  
  fd_scope = create_form_scope();
	      /* fill-in form initialization code */

  fl_set_form_atclose(fd_scope->scope,clear_scope_form, 0);
	      /* show the first form */
  icon= fl_read_pixmapfile(fl_default_win(), "SAA_small.xpm", width, height,0, hotx, hoty,0);
  fl_set_form_icon(fd_scope->scope, icon, 0);

	     /* fill-in form initialization code */

            //So that the left  image keeps displaying
  fl_hide_object(fd_scope->left_xyplot);
  fl_hide_object(fd_scope->right_xyplot);
  
  fl_add_canvas_handler(fd_scope->left_plot_canvas, Expose, expose_handle_left, 0);
//  fl_add_canvas_handler(fd_scope->left_plot_canvas, MotionNotify, motion_handle_left, 0);

            //So that the right image keeps displaying
  fl_add_canvas_handler(fd_scope->right_plot_canvas, Expose, expose_handle_right, 0);
//  fl_add_canvas_handler(fd_scope->right_plot_canvas, MotionNotify, motion_handle_right, 0);

       //Enabling image file formats
  flimage_enable_png();
  flimage_enable_xwd();
  flimage_enable_bmp();
  flimage_enable_xbm();
  flimage_enable_gif();
  flimage_enable_sgi();
  flimage_enable_fits();
  flimage_enable_xpm();
  flimage_enable_tiff();
  flimage_enable_ps();
#ifndef NO_JPEG
  flimage_enable_jpeg();
#endif


#if STUPID_WM
  vmode = fl_get_vclass();
  map = fl_create_colormap(fl_state[vmode].xvinfo,30);
  fprintf(stderr,"map=0x%x\n",map);
  fl_set_canvas_colormap(fd_scope->left_plot_canvas, map);
  fl_add_canvas_handler(fd_scope->left_plot_canvas, EnterNotify, expose_left_handle, 0);
  fl_set_canvas_colormap(fd_scope->right_plot_canvas, map);
  fl_add_canvas_handler(fd_scope->right_plot_canvas, EnterNotify, expose_right_handle, 0);
#endif


        //Setting up general parameters for image display 
  setup.app_data = fd_scope;
  setup.max_frames=100;
  setup.delay = 40;
  flimage_setup(&setup);

  curr_image_left=flimage_alloc();     //Allocating space for image structure.
  curr_image_right=flimage_alloc();     //Allocating space for image structure.
  curr_image_left->double_buffer = 1 ;
  curr_image_right->double_buffer = 1 ;
  fl_show_form(fd_scope->scope,FL_PLACE_CENTERFREE,FL_FULLBORDER,"scope");
  scope_button_flag.onoff=1;
  pthread_t thread_scope_sigrec;   //Thread
  pthread_create(&thread_scope_sigrec,NULL,scope_sigrec, (void *) &ptr); //Starting the thread
  tid = fl_add_timeout(30, chk_scope, NULL);  //Setting timed callback
  fl_do_forms();
  

  /*flimage_free(curr_image_left);*/  //To free the image memory
  return(0);
  /*fl_set_xyplot_data(ob,x.m[0],y.m[0],(int)END_n-(int)START_n, "Signal","time->", "Value");*/
  }


//Closing this source display window without killing application.
int clear_scope_form(FL_FORM *closing_form, void *n)
  {
  extern int tid;
  extern FD_scope *fd_scope;
  extern SCOPE_flags scope_button_flag;
  
  scope_button_flag.left_waveform_set=0;    //Setting all flags to zero
  scope_button_flag.right_waveform_set=0;
  scope_button_flag.left_right_set=0;
  scope_button_flag.left_specgram_set=0;
  scope_button_flag.right_specgram_set=0;
  
  while((scope_button_flag.left_right_set_ack != 1)&&(scope_button_flag.left_specgram_set_ack != 1) && (scope_button_flag.left_waveform_set_ack != 1) && (scope_button_flag.right_specgram_set_ack != 1) && (scope_button_flag.right_waveform_set_ack != 1))
    { //For ack from other threads
    }
  if(tid>0)
   fl_remove_timeout(tid);
  flimage_free(curr_image_left);
  flimage_free(curr_image_right);
  //printf("\n I am waiting for all to ack 3\n");
  fl_free_form(fd_scope->scope);
  fl_free((FD_scope *)fd_scope);
  fd_scope=NULL;
  scope_button_flag.onoff=0;
  return FL_IGNORE;
  }


   //Idle call back function to refresh the left plots
int chk_scope()
  {
  extern SCOPE_flags scope_button_flag;
  extern float *left_scope_data, *left_x, *right_scope_data, *right_x;
  int cnt=0,cnt2=0,cnt3=0,NO_STOP=1;
  
  while(NO_STOP)
    {
    fl_check_forms();
    if(fd_scope!=NULL)
      {
      if(cnt++==5)
        {
        fl_set_button(fd_scope->left_input_scope,scope_button_flag.left_waveform_set);
        fl_set_button(fd_scope->left_specgram_scope,scope_button_flag.left_specgram_set);
        fl_set_button(fd_scope->left_right_plot_scope,scope_button_flag.left_right_set);
        fl_set_button(fd_scope->right_input_scope,scope_button_flag.right_waveform_set);
        fl_set_button(fd_scope->right_specgram_scope,scope_button_flag.right_specgram_set);
        cnt=0;
        }  
      if(scope_button_flag.left_specgram_set==1)
        flimage_display(curr_image_left, FL_ObjWin(fd_scope->left_plot_canvas));
      if(scope_button_flag.right_specgram_set==1)
        flimage_display(curr_image_right, FL_ObjWin(fd_scope->right_plot_canvas));
      if(scope_button_flag.left_waveform_set==1)
        if(cnt2++==3)
          {
          fl_set_xyplot_data(fd_scope->left_xyplot,left_x,left_scope_data,(int)(8000/4-4), "","time->", "Value");
          cnt2=0;
          }
      if(scope_button_flag.right_waveform_set==1)
        if(cnt3++==3)
          {
          fl_set_xyplot_data(fd_scope->right_xyplot,right_x,right_scope_data,(int)(8000/4-4), "","time->", "Value");
          cnt3=0;
          }
      }
    else 
      {
      return(0);
      }
    }
  } 




#include "scope_left.c"
#include "scope_right.c"
#include "scope_sigrec.c"
