/*******************************************************
* Has all the functions required 
  signal reading
  signal ploting
  signal saving
*for SAA. 
********************************************************/
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <errno.h>
#include <math.h>
#include <string.h>
/*#include <gsl/gsl_linalg.h>*/
#include "source_display.h"


#define f_0 900.0
#define AUDIO "/dev/dsp"                                                        


/* Include this header file to use functions from libsndfile. */
#include <sndfile.h>

/*    This will be the length of the buffer used to hold.frames while
**    we process them.
*/
#define    BUFFER_LEN      1024                  //(VARIABLE)

/* libsndfile can handle more than 6 channels but we'll restrict it to 6. */
#define    MAX_CHANNELS    2                  //(VARIABLE)

//Prototypes of the funtions in this file
void sigplot_initialise(FL_OBJECT *ob1,FL_OBJECT *ob2);  //Initialise signal plot
void sigplot_update(FL_OBJECT *ob1,FL_OBJECT *ob2 );  //Update signal plot
static int post_sigplot(FL_OBJECT *ob, int ev, FL_Coord mx, FL_Coord my, int key, void *xev); //After sig plot
int sound_play();  //PLAY_REC is 0 for playing and 1 for recording
int sound_rec();  //PLAY_REC is 0 for playing and 1 for recording
void new_data();  //New data Data structure initialise
void open_file();  //Open file for reading
void save_as();  //Save to file
void save_file();  //Save to file
int source_plot_init(char *); // Initialzing the plotting the source.
void source_plot(); //Plotting the source.
int clear_source_display_form(FL_FORM *closing_form, void *n);


//Funtions


void sigplot_initialise(FL_OBJECT *ob1,FL_OBJECT *ob2)
  {
  int N=8000;
  int j;
  extern signal Data;     
  /*extern FL_OBJECT *channel1,*/
                 /* *channel2;*/
  free_mtrx(&Data.channels);
  Data.n_channels=1;      /*Number of channels*/
  Data.n_bytes=2;
  /*fl_set_button(channel1, 1);*/
  /*fl_set_button(channel2, 0);*/
  Data.fs=16000;           /*Sampling frequency in Hertz*/
  Data.fs_orig=16000;           /*Sampling frequency in Hertz*/
  Data.channels=creat_mtrx(Data.n_channels,N); /*Creating the data matrix*/
  Data.start_display1=0;    /*Display starting from 0*/
  Data.end_display1=(float)(N-1)/Data.fs; /*Time for N samples*/

  for(j = 0; j < N; j++)
    {
    /*x[j] = (float)j * 3.1415 / 10 + 0.2;*/
    Data.channels.m[0][j] = sin(2*f_0*(float)j*3.1415/Data.fs) + cos(f_0*(float)j*3.1415/Data.fs);
    }
    /*fl_set_xyplot_data(ob, x, y, N, "TestTitle","X-axis", "Y|axis");*/
  ob1->reserved[0]=0;  /*Flag*/
  ob2->reserved[0]=0;  /*Flag*/
  sigplot_update(ob1,ob2);
  }

void sigplot_update(FL_OBJECT *ob1,FL_OBJECT *ob2 )     //Updates the signal plot.
  {
  char DATA_LEN[8];
  extern signal Data;     
  extern FL_OBJECT *channel1, *channel2, *time_rec;
  float END_n,START_n;                                  //
  int n;                                  //Temporary variable.
  int SUB_SAMP_RATE;                                    //By what fraction the sequence is to be subsampled.
  matrix x,y;
  END_n=(Data.end_display1*Data.fs);                    //Final index point to be displayed.
  START_n=(Data.start_display1*Data.fs);                //Starting index point
  SUB_SAMP_RATE=rintf(Data.fs/8000);
  sprintf(DATA_LEN,"%2.3f",Data.end_display1);
  fl_set_input(time_rec,DATA_LEN);
  if(END_n<=Data.channels.col)
    {
    x=creat_mtrx(1,(int)rintf((END_n-START_n)/SUB_SAMP_RATE));
    y=creat_mtrx(1,(int)rintf((END_n-START_n)/SUB_SAMP_RATE));
    for(n=0;n<(int)rintf((END_n-START_n)/SUB_SAMP_RATE);n=n++)
      {
      x.m[0][n]=(float)(n*SUB_SAMP_RATE)/Data.fs;
      y.m[0][n]=Data.channels.m[0][(int)START_n+n*SUB_SAMP_RATE];
      }
    fl_set_xyplot_data(ob1,x.m[0],y.m[0],(int)rintf((END_n-START_n)/SUB_SAMP_RATE), "Signal","time->", "Value");
    free_mtrx(&x);
    free_mtrx(&y);
    switch((int)Data.fs)
      {
      case 8000:
	fl_set_button(F_s1, 1);
        fl_set_button(F_s2, 0);
        fl_set_button(F_s3, 0);
	break;
      case 16000:
	fl_set_button(F_s2, 1);
        fl_set_button(F_s1, 0);
        fl_set_button(F_s3, 0);
	break;
      case 44100:
	fl_set_button(F_s3, 1);
        fl_set_button(F_s1, 0);
        fl_set_button(F_s2, 0);
	break;
      default:
	break;
      }
    if(Data.n_channels==2)
      {
      fl_set_button(channel1, 0);
      fl_set_button(channel2, 1);
      END_n=(Data.end_display2*Data.fs);
      START_n=(Data.start_display2*Data.fs);
      x=creat_mtrx(1,(int)rintf((END_n-START_n)/SUB_SAMP_RATE));
      y=creat_mtrx(1,(int)rintf((END_n-START_n)/SUB_SAMP_RATE));
      for(n=0;n<(int)rintf((END_n-START_n)/SUB_SAMP_RATE);n++)
        {
        x.m[0][n]=(float)(n*SUB_SAMP_RATE)/Data.fs;
        y.m[0][n]=Data.channels.m[1][(int)START_n+n*SUB_SAMP_RATE];
        }
      fl_set_xyplot_data(ob2,x.m[0],y.m[0],(int)rintf((END_n-START_n)/SUB_SAMP_RATE), "Signal","time->", "Value");
      free_mtrx(&x);
      free_mtrx(&y);
      } 
    else
      {
      fl_set_button(channel1, 1);
      fl_set_button(channel2, 0);
      x=creat_mtrx(1,1);
      x.m[0][0]=0;
      fl_set_xyplot_data(ob2,x.m[0],x.m[0],1," ","time->", "Value");
      free_mtrx(&x);
      } 
    }
  }

static int post_sigplot(FL_OBJECT *ob, int ev, FL_Coord mx, FL_Coord my, int key, void *xev)
  {
  /*fl_set_xyplot_inspect(ob, 1);*/ /*In this mode then fl_get_xyplot works */
  /*printf("Visited sigplot \n");*/
  float wx, wy;
  extern signal Data;     
  if(ev == FL_PUSH || ev == FL_MOUSE)
    {
      /*float data_x[1],data_y[1];*/
      /*int i[1];*/
      char buf[64];
      /*fl_get_xyplot(ob, data_x, data_y, i);*/
      /*fl_set_xyplot_data(ob,&wx,&wy,&i,ob->title,ob->xlabel,ob->ylabel);*/

      fl_xyplot_s2w(ob, mx,  my, &wx, &wy);
      if(ev == FL_PUSH)
         {
         ob->reserved[0]=1;
         if(ob->reserved[1]==1)
            Data.start_display1=mx;
         else
            Data.start_display2=mx;
         }
      /*sprintf(buf,"x=%d y=%d wx=%.3f wy=%.3f", mx, my, wx, wy);*/
      sprintf(buf,"time=%.3f value=%.3f", wx, wy);
      fl_show_oneliner(buf, ob->x + ob->form->x + 5, ob->y + ob->form->y);
     /*fl_object_ps_dump(ob,"test.ps"); */
      ob->wantkey = FL_KEY_ALL;
      ob->input = 1;
    }
  else if(ev == FL_RELEASE)
    {
      fl_hide_oneliner();
      if(ob->reserved[0]==1)
        {
        ob->reserved[0]=0;
        fl_xyplot_s2w(ob, mx,  my, &wx, &wy);
        if(ob->reserved[1]==1)
          Data.end_display1=mx;
        else
          Data.end_display2=mx;
     }
  }
  else if(ev == FL_KEYBOARD)
    {
        fprintf(stderr,"key=%d\n",key);
    }
  return 0;
  }

/*******************************************
 * For displaying the recovered sources. Starting
 * the form with that display
 *
 * *****************************************/

FD_source_display *fd_source_display;  //Global
int source_plot_init(char *source_diplay_name)
  {
  Pixmap icon;
  unsigned width[0],height[0],hotx[0],hoty[0];
  extern FD_source_display *fd_source_display;
  if (fd_source_display)
    return; 

  fd_source_display = create_form_source_display();
  source_plot();
	      /* fill-in form initialization code */

  fl_set_form_atclose(fd_source_display->source_display,clear_source_display_form, 0);
	      /* show the first form */
  icon= fl_read_pixmapfile(fl_default_win(), "/usr/share/pixmaps/SAA_small.xpm", width, height,0, hotx, hoty,0);
  fl_set_form_icon(fd_source_display->source_display, icon, 0);
  fl_show_form(fd_source_display->source_display,FL_PLACE_CENTERFREE,FL_FULLBORDER,source_diplay_name);
  fl_do_forms();
  free(source_diplay_name);
  return(0);
  /*fl_set_xyplot_data(ob,x.m[0],y.m[0],(int)END_n-(int)START_n, "Signal","time->", "Value");*/
  }

int SOURCE_CHKD;         //The source marked for processing like playing, deleting  and saving
void source_plot()
  {
  extern FD_source_display *fd_source_display;
  extern signal Data;
  extern int N_SOURCE;
  extern int SOURCE_CHKD;
  extern source *SOURCE;
  matrix x,y,zeros;
  int q,n;
  int SUB_SAMP_RATE;                                    //By what fraction the sequence is to be subsampled.
  
  SUB_SAMP_RATE=rintf(Data.fs/8000);
  SOURCE_CHKD=0;
  x=creat_mtrx(1,(int)rintf(Data.channels.col/SUB_SAMP_RATE));
  y=creat_mtrx(1,(int)rintf(Data.channels.col/SUB_SAMP_RATE));
  for(q=0;q<SOURCE_NUM;q++)
    {
    if(q<N_SOURCE)                 //For detected sources make data to be the SOURCE.sig
      {
      for(n=0;n<(int)rintf((SOURCE[q].L_init+SOURCE[q].L_src)/SUB_SAMP_RATE);n++)
        {
        x.m[0][n]=(float)(n*SUB_SAMP_RATE)/Data.fs;
        y.m[0][n]=SOURCE[q].sig[n*SUB_SAMP_RATE];
        }
      }
    else                     //For other plots make data to be 0
      {
      for(n=0;n<(int)rintf(Data.channels.col/SUB_SAMP_RATE);n++)
        {
        x.m[0][n]=(float)(n*SUB_SAMP_RATE)/Data.fs;
        y.m[0][n]=0;
        }
      }
    switch(q)
      {
      case 0:
        fl_set_xyplot_data(fd_source_display->sxyplot1,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 1:
        fl_set_xyplot_data(fd_source_display->sxyplot2,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 2:
        fl_set_xyplot_data(fd_source_display->sxyplot3,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 3:
        fl_set_xyplot_data(fd_source_display->sxyplot4,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 4:
        fl_set_xyplot_data(fd_source_display->sxyplot5,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 5:
        fl_set_xyplot_data(fd_source_display->sxyplot6,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 6:
        fl_set_xyplot_data(fd_source_display->sxyplot7,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      case 7:
        fl_set_xyplot_data(fd_source_display->sxyplot8,x.m[0],y.m[0],(int)rintf(Data.channels.col/SUB_SAMP_RATE), "Signal","time->", "Value");
        break;
      default:
        break;
      }
    }
  free_mtrx(&x);
  free_mtrx(&y);
  }

//Closing this source display window without killing application.
int clear_source_display_form(FL_FORM *closing_form, void *n)
  {
  extern FD_source_display *fd_source_display;
  extern int N_SOURCE;
  extern int SOURCE_CHKD;
  extern source *SOURCE;
  int src;

  for(src=0;src<N_SOURCE;src++)
   {
   free(SOURCE[src].sig);
   SOURCE[src].sig=NULL;
   }
  free(SOURCE);
  SOURCE=NULL;
  SOURCE_CHKD=0;
  N_SOURCE=0;
  /*fl_free_form(fd_source_display->source_display);
  fl_free((FD_source_display *)fd_source_display);
  fd_source_display=NULL;*/
  fl_free_form(fd_source_display->source_display);
  fl_free((FD_source_display *)fd_source_display);
  fd_source_display=NULL;
  return FL_IGNORE;
  }

extern void to_main_cb(FL_OBJECT *ob, long x)
{
 int n;
 extern FD_source_display *fd_source_display;
 clear_source_display_form(fd_source_display->source_display, &n );
}

//To play the source chosen from among the recovered sources.
extern void play_source_cb(FL_OBJECT *ob, long x)
  {
  int setting = 0x000C000D; // 12 fragments size 8kb         (VARIABLE)
  int format = AFMT_U8;
  int rate;
  unsigned char* data;
  int audio_fd,abuf_size,frag_size,mixer_fd;
  int stereo;     /* 0=mono, 1=stereo */
  int len,q,i,n,cnt=0,count,choice;
  int mask;                     //Mask for mixer control
  extern source *SOURCE;   
  extern signal Data;   
  extern int SOURCE_CHKD;
  extern int N_SOURCE;
  int END_n;
  audio_buf_info info;          //The parameters of buffering

  if(SOURCE_CHKD>=N_SOURCE)
    {
    fl_show_messages("No source of that number");
    return;
    }
  q=SOURCE_CHKD;    //SOurce to be played

  abuf_size=8192;              //(VARIABLE)
  rate=(int)Data.fs;
  
  if(Data.fs!=Data.fs_orig)
    if(!fl_show_question("The data is at a different frequency \n Should it be played?", 0))
      return;
   
  stereo=1;
  if(Data.n_bytes==1)
    format=AFMT_U8;
  else if (Data.n_bytes==2) 
    format=AFMT_S16_LE;
  else
    return ;
  if((Data.channels.col!=0))
    {
    END_n=SOURCE[q].L_init+SOURCE[q].L_src;
 
    //Opening device for writing
    if((audio_fd = open("/dev/dsp",O_WRONLY, 0)) == -1)
      {                               // Opening device failed 
      perror("/dev/dsp");
      return;
      }
    }
  if( ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format) == -1 ) 
    {
    perror("ioctl set fragment");
    return ;
    }
  if (ioctl(audio_fd, SNDCTL_DSP_STEREO, &stereo)==-1)
    { /* Fatal error */
    perror("SNDCTL_DSP_STEREO");
    return ;
    }
  if( ioctl(audio_fd,SNDCTL_DSP_SPEED,&rate) == -1 )
    {
    perror("ioctl sample rate");
    return ;
    }
  ioctl(audio_fd, SNDCTL_DSP_GETBLKSIZE, &abuf_size);
  if(abuf_size < 1024 || abuf_size > (2*65536))
    {
    if (abuf_size == -1)
      perror (AUDIO);
    else
      fprintf (stderr, "Invalid audio buffers size %d\n", abuf_size);
    exit (-1);
    }
  count=(Data.channels.row * Data.n_bytes * END_n);//Total number of samples required in the time interval
  data=calloc(count,sizeof(unsigned char));
  for (i = 0;i<END_n; i++) 
    {
    data[4*i] =(unsigned char)(((signed short)(32768*(SOURCE[q].sig[i])))&0xff);      // set left channel    (VARIABLE)
    data[4*i+1] = (unsigned char)((((signed short)(32768*(SOURCE[q].sig[i]))) >> 8)&0xff);      // set left channel (VARIABLE)
    data[4*i+2] = data[4*i];    // right channel
    data[4*i+3] = data[4*i+1];    // right channel
    /*data[2*i+1] = (unsigned char)((((signed short)(32768*(SOURCE[q].sig[(int)START_n+i]))) >> 8) & 0xff);    // right silence*/
    }
    //Writing data to the device.
  if((len = write(audio_fd, data, count)) == -1)
    {
    perror("audio write");
    return ;
    }
    //Closing the audio device
  free(data);
  data=NULL;
  close(audio_fd);
  }

extern void save_source_cb(FL_OBJECT *ob, long x)
  {
  char* File_Name;
  size_t N_char;
  char* exten=".dat";
  FILE* fp;
  SNDFILE *outfile;
  extern source *SOURCE;
  extern signal Data;
  int n, k ,chnl,readcount,filetype ;
  SF_INFO sfinfo ;
  extern int SOURCE_CHKD;
 /* This is a buffer of double precision floating point values
    ** which will hold our data while we process it.
    */
  static float buffer_data [BUFFER_LEN] ;
  filetype=SF_FORMAT_WAV | SF_FORMAT_PCM_16;             // (VARIABLE) To be set according to choice of the user.
  
  if(File_Name=fl_show_fselector("Save as" ,".", "*.*",""))
    {
    N_char=strlen(File_Name);
    if(N_char>5)
    if((File_Name[N_char-1]==exten[3]) &&(File_Name[N_char-2]==exten[2]) && (File_Name[N_char-3]==exten[1]) && (File_Name[N_char-4]==exten[0]))
      {
      fp = fopen(File_Name,"w");
      for(n=0;n<(SOURCE[SOURCE_CHKD].L_src+SOURCE[SOURCE_CHKD].L_init);n++)
        fprintf(fp,"%f\n",SOURCE[SOURCE_CHKD].sig[n]);

        //Closing file
      fclose(fp);
      }
    else  
      {
      
      sfinfo.format=filetype;       //Seeting format of the output file.
      sfinfo.samplerate=(int)Data.fs; //Setting sampling rate
      sfinfo.channels=1;        //Setting the number of channels

      if(!(outfile = sf_open (File_Name, SFM_WRITE, &sfinfo)))    /* Open the output file. */
        {   
        fl_show_messages("Not able to open output file.");
        puts (sf_strerror (NULL)) ;
        return  ;
        } 
         /* While there are.frames  read them to buffer
        ** and write them to the output file.
        */
      k=0;
      for(n=0;n<(SOURCE[SOURCE_CHKD].L_src+SOURCE[SOURCE_CHKD].L_init);n++)
	{
        for(chnl=0;chnl<sfinfo.channels;chnl++)                 //Over the channels
          {
          buffer_data[k]=SOURCE[SOURCE_CHKD].sig[n];
          k++;
          }
	if(k==BUFFER_LEN)
          {   
	  sf_write_float(outfile, buffer_data, k) ;
	  k=0;
	  }
	}
      if(k<BUFFER_LEN)
        {   
	sf_write_float(outfile, buffer_data, k) ;
	}
      sf_close (outfile);
      }
    }
  else
    {
    fl_show_messages("Invalid file name.");
    }
}


//Deleting the marrked source.
void delete_marked_src_cb(FL_OBJECT *ob, long data)
  {
  extern int N_SOURCE;   //Number of sources in the source structure.
  extern int SOURCE_CHKD;
  extern source *SOURCE;
  int src,src_tmp,N_SOURCE_tmp;
  source *SOURCE_tmp;

  SOURCE_tmp=(source *)calloc(SOURCE_NUM,sizeof(source));       //Temporary SOURCE variable
  N_SOURCE_tmp=N_SOURCE;
  N_SOURCE=0;
  src_tmp=0;
  for(src=0;src<N_SOURCE_tmp;src++)                  //Over all sources detected
    {
    if(src!=(SOURCE_CHKD))                        //If not the one cheked for deletion 
      {
      SOURCE_tmp[N_SOURCE]=SOURCE[src];
      N_SOURCE++;
      SOURCE[src].DOA_SET=0;
      SOURCE[src].L_src=0;             //Length of source signal after initialising.
      SOURCE[src].L_init=0;    //Length of source signal after initialising.
      SOURCE[src].PF_SET=0;                 //Set PF_SET to 0 saying that PF has not been set
      SOURCE[src].WT=0;                //Reseting to 0.
      SOURCE[src].WTDOA=0;            // Reseting to 0.
      }
    else          //Else free the source
      {
      free(SOURCE[src].sig);
      SOURCE[src].sig=NULL;

      SOURCE[src].DOA_SET=0;
      SOURCE[src].L_src=0;             //Length of source signal after initialising.
      SOURCE[src].L_init=0;    //Length of source signal after initialising.
      SOURCE[src].PF_SET=0;                 //Set PF_SET to 0 saying that PF has not been set
      SOURCE[src].WT=0;                //Reseting to 0.
      SOURCE[src].WTDOA=0;            // Reseting to 0.
      }
    }
  for(src=0;src<N_SOURCE;src++)       //Implementing SOURCE=SOURCE_tmp;
    {
    SOURCE[src]=SOURCE_tmp[src];              //Storing back the undeleted sources.
    }
  free(SOURCE_tmp);                 
  source_plot();                     //Updating the source display.
  }

void save_all_src_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}



#define BUF_SIZE 8192     
int sound_play()  //PLAY_REC is 0 for playing and 1 for recording
  {
  int setting = 0x000C000D; // 12 fragments size 8kb
  int format = AFMT_U8;
  int rate;
  unsigned char* data;
  int audio_fd,abuf_size,frag_size,mixer_fd;
  int stereo;     /* 0=mono, 1=stereo */
  int len,i,n,cnt=0,count,choice;
  int mask;                     //Mask for mixer control
  extern signal Data;   
  float END_n,START_n;
  audio_buf_info info;          //The parameters of buffering
  char *msg_str;

  if(Data.channels.col>0)
    {
    abuf_size=8192;
    rate=(int)Data.fs;
    
    //Checking use of mtrx_to_cmtrx()
    //cmatrix CMAT_chk;
    //CMAT_chk=creat_cmtrx(Data.channels.row,Data.channels.col);
    //CMAT_chk=mtrx_to_cmtrx(&Data.channels);
    //free_cmtrx(&CMAT_chk);
    
    if(Data.fs!=Data.fs_orig)
      if(!fl_show_question("The data is at a different frequency \n Should it be played?", 0))
        return -1;
     
    if(Data.n_channels==2)
      {
      stereo=1;
      if(Data.channels.row==1)
         {
         if(!fl_show_question("The data is single channel \n Request is to play 2 channel. \n Should it be played?", 0))
               return -1;
         else
               stereo=0;
         }
      }
    else
      stereo=0;
    if(Data.n_bytes==1)
      format=AFMT_U8;
    else if (Data.n_bytes==2) 
      format=AFMT_S16_LE;
    else
      return -1;
 
 
      END_n=(Data.end_display1*Data.fs);
      START_n=(Data.start_display1*Data.fs);
  
      //Opening device for writing
      if((audio_fd = open("/dev/dsp",O_WRONLY, 0)) == -1)
        {                               // Opening device failed 

        perror("/dev/dsp");
        return errno;
        }

    if( ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format) == -1 ) 
      {
      perror("ioctl set fragment");
      return errno;
      }
    if (ioctl(audio_fd, SNDCTL_DSP_STEREO, &stereo)==-1)
      { /* Fatal error */
      perror("SNDCTL_DSP_STEREO");
      return errno;
      }
    /*if( ioctl(audio_fd,SNDCTL_DSP_SPEED,&rate) == -1 )*/
    if( ioctl(audio_fd,SOUND_PCM_WRITE_RATE,&rate) == -1 )
      {
      fl_show_messages("Sample rate could not be set");
      perror("ioctl sample rate");
      return errno;
      }
    if(rate!=Data.fs)
      {
      msg_str=(char *)calloc(100,sizeof(char));
      sprintf(msg_str,"Could not set sample rate to %d. Set to %d",(int)Data.fs,(int)rate);
      fl_show_messages(msg_str);
      free(msg_str);
      }

    ioctl(audio_fd, SNDCTL_DSP_GETBLKSIZE, &abuf_size);              
    if(abuf_size < 1024 || abuf_size > (2*65536))
      {
      if (abuf_size == -1)
        perror (AUDIO);
      else
        fprintf (stderr, "Invalid audio buffers size %d\n", abuf_size);
      exit (-1);
      }
    count=(int)(Data.channels.row * Data.n_bytes * (END_n-START_n));//Total number of samples required for 5 sec.
    data=calloc(count,sizeof(unsigned char));
    if(Data.channels.row==2)
      {
      if(Data.n_bytes==2)
        {
        for (i = 0;i<(int)END_n-(int)START_n; i++) 
          {
          data[4*i] =(unsigned char)(((signed short)(32768*(Data.channels.m[0][(int)START_n+i])))&0xff);      // set left channel
          data[4*i+1] = (unsigned char)((((signed short)(32768*(Data.channels.m[0][(int)START_n+i]))) >> 8)&0xff);      // set left channel
          data[4*i+2] = (unsigned char)(((signed short)(32768*(Data.channels.m[1][(int)START_n+i])))&0xff);    // right silence
          data[4*i+3] = (unsigned char)((((signed short)(32768*(Data.channels.m[1][(int)START_n+i]))) >> 8)&0xff);    // right silence
          }
        }
      else
        {
        for (i = 0;i<(int)END_n-(int)START_n; i++) 
          {
          data[2*i] =(unsigned char)(128*(Data.channels.m[0][(int)START_n+i]+1));      // set left channel
          data[2*i+1] = (unsigned char)(128*(Data.channels.m[1][(int)START_n+i]+1));    // right silence
          }
        }
      }
    else
      {
      if(Data.n_bytes==2)
        {
        for (i = 0;i<(int)END_n-(int)START_n; i++) 
          {
          data[2*i] =(unsigned char)((signed short)(32768*(Data.channels.m[0][(int)START_n+i]))&0xff);      // set left channel
          data[2*i+1] = (unsigned char)((((signed short)(32768*(Data.channels.m[0][(int)START_n+i]))) >> 8) & 0xff);    // right silence
          }
        }
      else
        {
        for (i = 0;i<(int)END_n-(int)START_n; i++) 
          {
          data[i] =(unsigned char)(128*(Data.channels.m[0][(int)START_n+i]+1));      // set left channel
              }
        } 
     }
        	
      //Writing data to the device.
    if ((len = write(audio_fd, data, count)) == -1)
      {
      fl_show_messages("audio write error");
      perror("audio write");
      return errno;
      }
      //Closing the audio device
    free(data);
    data=NULL;
    close(audio_fd);
    }
  else
    {
    fl_show_messages("Nothing to play");
    }
  }

int sound_rec()  //PLAY_REC is 0 for playing and 1 for recording
  {
  int setting = 0x000C000D; // 12 fragments size 8kb
  int format = AFMT_S16_LE;
  int rate;
  unsigned char* data;
  int audio_fd,abuf_size,frag_size,mixer_fd;
  int stereo,n_bytes;     /* chnsl=1 for mono, 2 for stereo */
  int count,count_prev,l,c,len,i,n,cnt=0,cnt_samples;
  int mask;                     //Mask for mixer control
  extern signal Data;   
  extern FL_OBJECT *signal_plot1;
  extern FL_OBJECT *signal_plot2;
  extern FL_OBJECT *time_rec;
  float END_n,START_n;
  unsigned char *audio_buffer;
  char *msg_str;
  char DATA_LEN[8];
  
  /*unsigned char audio_buffer[BUF_SIZE];*/
  audio_buf_info info;          //The parameters of buffering
  abuf_size=4096;
  
  if(Data.end_display1*Data.fs <= abuf_size)
    {
    msg_str=(char *)calloc(100,sizeof(char));
    sprintf(msg_str,"Please enter the time for recording");
    fl_show_messages(msg_str); 
    free(msg_str);
    return;
    }
  else
    {
  //Data.end_display1=5;
    Data.file_name_set=0;
    //Data.n_bytes=2;
    rate=(int)Data.fs;
    if(Data.n_channels==2)
      stereo=1;
    else
      stereo=0;
    if(Data.n_bytes==1)
      format=AFMT_U8;
    else if (Data.n_bytes==2) 
      format=AFMT_S16_LE;
    else
      return -1;
    
    Data.file_name_set=0;    //So that new file name is asked.
 
    if((audio_fd = open("/dev/dsp",O_RDONLY, 0)) == -1)
      {                               // Opening device failed 
      perror("/dev/dsp");
      return errno;
      }
 
    if( ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format) == -1 ) 
      {
      perror("ioctl set fragment");
      return errno;
      }
    if (ioctl(audio_fd, SNDCTL_DSP_STEREO, &stereo)==-1)
      { /* Fatal error */
      perror("SNDCTL_DSP_STEREO");
      return errno;
      }
    if( ioctl(audio_fd,SNDCTL_DSP_SPEED,&rate) == -1 )
      {
      perror("ioctl sample rate");
      return errno;
      }
    /*ioctl (audio_fd, SNDCTL_DSP_SETBLKSIZE, &abuf_size);*/
    ioctl (audio_fd, SNDCTL_DSP_GETBLKSIZE, &abuf_size);
    if(abuf_size < 1024 || abuf_size > (2*65536))
      {
      if (abuf_size == -1)
        perror (AUDIO);
      else
        fprintf (stderr, "Invalid audio buffers size %d\n", abuf_size);
      return -1;
      }
    count=(int)(Data.fs * Data.n_channels * Data.n_bytes * Data.end_display1/abuf_size)*abuf_size; //Total number of samples required for 5 sec.
    data=calloc(count,sizeof(unsigned char));
//    if(data=calloc(count,sizeof(unsigned char))== NULL)
//      {
//      fprintf (stderr, "Unable to allocate input/output buffer\n");
//      return(-1);
//      }
  audio_buffer = malloc(abuf_size);
//      {
//      fprintf (stderr, "Unable to allocate input/output buffer\n");
//      return(-1);
//      }
    count_prev=count;
    while(count>0)
      {
      if((len = read(audio_fd, audio_buffer, abuf_size)) > 0)
        {
        for(n=0;n<len;n++)
          {
          *(data+cnt)=*(audio_buffer+n);
          cnt++;
          }
        }
      else
        {
        close(audio_fd);
//      free(audio_buffer);
        free(data);
        data=NULL;
        return -1;
        }
      count-=len;
      
//    free(audio_buffer);
      cnt_samples=(int)(cnt/(Data.n_channels*Data.n_bytes));
      free_mtrx(&Data.channels);
      Data.channels=creat_mtrx(Data.n_channels,cnt_samples); /*Creating the data matrix*/ 
      Data.fs_orig=Data.fs;
      Data.start_display1=0;
      Data.end_display1=(float) (cnt_samples-1)/Data.fs;
      Data.start_display2=0;
      Data.end_display2=(float) (cnt_samples-1)/Data.fs;
      if (format==AFMT_U8)
        {
        if (stereo==0)
          {
          for(n = 0; n < cnt_samples-1; n++)
            {
            Data.channels.m[0][n] = ((float)(*(data+n)-128))/128 ;
            }
          }
        else if (stereo==1)
          {
          for(n = 0; n < cnt_samples-2; n++)
            {
            Data.channels.m[0][n] = ((float)(*(data+2*n)-128))/128 ;
            Data.channels.m[1][n] = ((float)(*(data+2*n+1)-128))/128 ;
            }
          }
        }
      else if(format==AFMT_S16_LE) 
        {
        if (stereo==0)
          {
          for(n = 0; n < cnt_samples-2; n++)
            {
            Data.channels.m[0][n]=((float)(short)(*(data+2*n) + 256*(*(data+2*n+1))))/32768;
            }
          }
        else if (stereo==1)
          {
          for(n = 0; n < cnt_samples-4; n++)
            {
             Data.channels.m[0][n]=((float)(short)(*(data+4*n) + 256*(*(data+4*n+1))))/32768;
             Data.channels.m[1][n]=((float)(short)(*(data+4*n+2) + 256*(*(data+4*n+3))))/32768;
            }
          }
        }
      sprintf(DATA_LEN,"%2.3f",Data.end_display1);  //Generating string for plotting time index
      fl_set_input(time_rec,DATA_LEN);       //Set the input time (SO that even when the condition below is notsatisfied
                                             //time is updated.
      if(cnt_samples< 100000)    //(VARIABLE). If number of samples is  > 220000 stop plotting
  //   if((count_prev-count>8000) && (count < 441000))    //(VARIABLE). If number of samples in the blockis > 20000
        {                                                 //and If maximum number of samples is less than 441000.
        count_prev=count;                                 //This maximum is to avoid delay when there is too many samples
        sigplot_update(signal_plot1,signal_plot2);  //Updating the plot in each cycle.
        }  
      sprintf(DATA_LEN,"%2.3f",Data.end_display1);
      }
    sigplot_update(signal_plot1,signal_plot2);   //Updating the display
    free(data);       //Freeing the buffer
    data=NULL;
    close(audio_fd);  //Closing the device
    }
  }


//Initialize a new data structure and main plot
void new_data()
  {   
  extern signal Data;
  extern FL_OBJECT *signal_plot1;
  extern FL_OBJECT *signal_plot2;

  if((Data.channels.col!=0)&&(Data.channels.row!=0))
    {
    free_mtrx(&Data.channels);
    Data.fs_orig=Data.fs;
/*    fl_set_button(F_s2,1);
    fl_set_button(F_s1,0);
    fl_set_button(F_s3,0);
    fl_set_button(F_s4,0); */
    Data.file_name_set=0;   //So that new file name is asked.
    Data.n_channels=2;
    fl_set_button(channel2,1);
    fl_set_button(channel1,0);
    Data.n_bytes=2;
    fl_set_button(bytes2,1);
    fl_set_button(bytes1,0);
    }
  Data.start_display1=0;
  Data.end_display1=0;  
  Data.start_display2=0;
  Data.end_display2=0;  
  sigplot_update(signal_plot1,signal_plot2); 
  }

//Open file and check. Then if OK use read.
void open_file()        
  {   
  size_t N_char;
  char* File_Name;
  char* SAA_window_label;
  char* exten=".dat";
  FILE* fp;
  SNDFILE *infile;
  extern signal Data;
  extern FL_FORM *audio_processer;
  extern FL_OBJECT *signal_plot1;
  extern FL_OBJECT *signal_plot2;
  int LENGTH=0,chnl,l,n;
  int readcount ;
   /* This is a buffer of double precision floating point values
    ** which will hold our data while we process it.
    */
  static double buffer_data [BUFFER_LEN] ;
  SAA_window_label=(char *)calloc(300,sizeof(char));
    /* A pointer to an SF_INFO stutct is passed to sf_open.
    ** On read, the library fills this struct with information about the file.
    ** On write, the struct must be filled in before calling sf_open.
    */ 
  SF_INFO      sfinfo ;
  
      /* Here's where we open the input file. We pass sf_open the file name and
    ** a pointer to an SF_INFO struct.
    ** On successful open, sf_open returns a SNDFILE* pointer which is used
    ** for all subsequent operations on that file. 
    ** If an error occurs during sf_open, the function returns a NULL pointer.
	**
	** If you are trying to open a raw headerless file you will need to set the 
	** format and channels fields of sfinfo before calling sf_open(). For 
	** instance to open a raw 16 bit stereo PCM file you would need the following
	** two lines:
	**	
	**		sfinfo.format   = SF_FORMAT_RAW | SF_FORMAT_PCM_16 ;
	**		sfinfo.channels = 2 ;
    */

  if(File_Name=fl_show_fselector("Open File" ,".", "*.*",""))  //Get the file name
    {
    N_char=strlen(File_Name);
    if(N_char>5)
    if((File_Name[N_char-1]==exten[3]) &&(File_Name[N_char-2]==exten[2]) && (File_Name[N_char-3]==exten[1]) && (File_Name[N_char-4]==exten[0]))  //If .dat file
      {
      if(fp = fopen(File_Name,"r"))
        {
        fclose(fp);
        new_data();     
        free_mtrx(&Data.channels);
	        //Reading file and setting the parameters.
        Data.channels=rd(File_Name);
        Data.n_channels=Data.channels.row;
        Data.start_display1=0;
        Data.end_display1=(Data.channels.col-1)/Data.fs;
        if(Data.n_channels==2) 
          {
          Data.start_display2=0;
          Data.end_display2=(Data.channels.col-1)/Data.fs;
          }
                //Setting the file name variable and saying that it is set.
	if(Data.file_name_set==1)
	  free(Data.file_name);
        Data.file_name=(char *)calloc(N_char,sizeof(char));
        Data.file_name_set=1;
        for(n=0;n<N_char;n++)
	  {
	  Data.file_name[n]=File_Name[n];
	  }
	   //Updateing the signal plot
        sigplot_update(signal_plot1,signal_plot2);
        }
      else  
        {
        fl_show_messages("Invalid file name.");
        }
      }
    else                    //Not a .dat file so use sndfile lib for reading
      {
//For reading a general file
//THis is using libsnfile library by  Erik
//at http://www.zip.com.au/~erikd/libsndfile/

      if (! (infile = sf_open (File_Name, SFM_READ, &sfinfo)))
        {   /* Open failed so print an error message. */
        fl_show_messages("Not able to open input file");
           /* Print the error message from libsndfile. */
        puts (sf_strerror (NULL)) ;
        return  ;
        } 
  
      if (sfinfo.channels > MAX_CHANNELS)
        {   
        fl_show_messages("Not able to process more that 2 channels");
        return ;
        } 
      new_data();
      free_mtrx(&Data.channels);
      Data.channels = creat_mtrx(sfinfo.channels,1);               //Initialising the buffer
      Data.fs_orig=(float)sfinfo.samplerate;
      Data.fs=(float)sfinfo.samplerate;
      Data.n_channels=sfinfo.channels;
      Data.n_bytes=2;
        /* While there are.frames in the input file, read them, process
        ** them and write them to the output file.
        */
      while ((readcount = sf_read_double (infile, (double *)buffer_data, BUFFER_LEN)))
        {   
        LENGTH+=readcount;
        for(chnl=0;chnl<sfinfo.channels;chnl++)                 //Over the channels
          {
          Data.channels.m[chnl]=(float *)realloc(Data.channels.m[chnl],LENGTH*sizeof(float)/sfinfo.channels);   //Allocating memory
          Data.channels.col=LENGTH/sfinfo.channels;                             //Setting length of the channels.
          for(l=chnl;l<BUFFER_LEN;l+=sfinfo.channels)                           //Filling in the data in the matrix in the correct order.
                    {
                    Data.channels.m[chnl][((LENGTH-BUFFER_LEN)+(l-chnl))/sfinfo.channels]=(float)buffer_data[l];
                    }
          }
        }
      Data.start_display1=0;
      Data.end_display1=((float)Data.channels.col-1)/(float)sfinfo.samplerate;          //Setting lengtht to be displayed
      if(Data.n_channels==2) 
        {
        Data.start_display2=0;
        Data.end_display2=((float)Data.channels.col-1)/(float)sfinfo.samplerate;        //Setting length to be displyed.
        }
  
      sf_close (infile) ;                                              // Closing the file.
                //Setting the file name variable.
      if(Data.file_name_set==1)
        free(Data.file_name);
      Data.file_name=(char *)calloc(N_char,sizeof(char));
      Data.file_name_set=1;
      for(n=0;n<N_char;n++)
	{
	Data.file_name[n]=File_Name[n];
	}
      sprintf(SAA_window_label,Data.file_name);
      SAA_window_label=strcat(SAA_window_label,"  SAA (SSPLab Audio Analyzer)"); //Creating new window label
      fl_set_form_title(audio_processer, (const char *)SAA_window_label);              //Updating the window label
      free(SAA_window_label);                                          //Freeeing the reserved space
      sigplot_update(signal_plot1,signal_plot2);                       //Plotting the signal
      }
    }
  }
  
//Save signals . It will ask for file name.
void save_as()
  {   
  
  char* File_Name;
  size_t N_char;
  char* exten=".dat";
  FILE* fp;
  SNDFILE *outfile;
  extern signal Data;
  int n, k ,chnl,readcount,filetype ;
  SF_INFO sfinfo ;
 /* This is a buffer of double precision floating point values
    ** which will hold our data while we process it.
    */
 static float buffer_data [BUFFER_LEN] ;



  filetype=SF_FORMAT_WAV | SF_FORMAT_PCM_16;             // (VARIABLE) To be set according to choice of the user.
  if(File_Name=fl_show_fselector("Save as" ,".", "*.*",""))
    {
    N_char=strlen(File_Name);
    if(N_char>5)
    if((File_Name[N_char-1]==exten[3]) &&(File_Name[N_char-2]==exten[2]) && (File_Name[N_char-3]==exten[1]) && (File_Name[N_char-4]==exten[0]))
      {
      fp = fopen(File_Name,"w");
      for(n=0;n<Data.channels.col;n++)
        if((Data.channels.row==2) && (Data.n_channels == 2))
          fprintf(fp,"%f \t %f \n",Data.channels.m[0][n],Data.channels.m[1][n]);
        else
          fprintf(fp,"%f\n",Data.channels.m[0][n]);

                //Setting the file name variable.
      if(Data.file_name_set==1)
        free(Data.file_name);
      Data.file_name=(char *)calloc(N_char,sizeof(char));
      Data.file_name_set=1;
      for(n=0;n<N_char;n++)
	{
	Data.file_name[n]=File_Name[n];
	}

        //Closing file
      fclose(fp);
      }
    else  
      {
      
      sfinfo.format=filetype;       //Seeting format of the output file.
      sfinfo.samplerate=(int)Data.fs; //Setting sampling rate
      sfinfo.channels=(int)Data.n_channels;        //Setting the number of channels

      if(!(outfile = sf_open (File_Name, SFM_WRITE, &sfinfo)))    /* Open the output file. */
        {   
        fl_show_messages("Not able to open output file.");
        puts (sf_strerror (NULL)) ;
        return  ;
        } 
         /* While there are.frames  read them to buffer
        ** and write them to the output file.
        */
      k=0;
      for(n=0;n<Data.channels.col;n++)
	{
        for(chnl=0;chnl<sfinfo.channels;chnl++)                 //Over the channels
          {
          buffer_data[k]=Data.channels.m[chnl][n];
          k++;
          }
	if(k==BUFFER_LEN)
          {   
	  sf_write_float(outfile, buffer_data, k) ;
	  k=0;
	  }
	}
      if(k<BUFFER_LEN)
        {   
	sf_write_float(outfile, buffer_data, k) ;
	}
                //Setting the file name variable.
      if(Data.file_name_set==1)
        free(Data.file_name);
      Data.file_name=(char *)calloc(N_char,sizeof(char));
      Data.file_name_set=1;
      for(n=0;n<N_char;n++)
	{
	Data.file_name[n]=File_Name[n];
	}
      sf_close (outfile);
      }
    }
  else
    {
    fl_show_messages("Invalid file name.");
    }
  }

//Save file to the file name if set. If not set it will call save_as
void save_file()
  {   
  size_t N_char;
  char* exten=".dat";
  FILE* fp;
  SNDFILE *outfile;
  extern signal Data;
  int n, k ,chnl,readcount,filetype ;
  SF_INFO sfinfo ;
 /* This is a buffer of double precision floating point values
    ** which will hold our data while we process it.
    */
  static float buffer_data [BUFFER_LEN] ;                //For storing the block for writing.

  filetype=SF_FORMAT_WAV | SF_FORMAT_PCM_16;             // (VARIABLE) To be set according to choice of the user.
  if(Data.file_name_set==1)
    {
    N_char=strlen(Data.file_name);
    if((Data.file_name[N_char-1]==exten[3]) &&(Data.file_name[N_char-2]==exten[2]) && (Data.file_name[N_char-3]==exten[1]) && (Data.file_name[N_char-4]==exten[0]))
      {
      fp = fopen(Data.file_name,"w");
      for(n=0;n<Data.channels.col;n++)
        if((Data.channels.row==2) && (Data.n_channels == 2))
          fprintf(fp,"%f \t %f \n",Data.channels.m[0][n],Data.channels.m[1][n]);
        else
          fprintf(fp,"%f\n",Data.channels.m[0][n]);
      fclose(fp);
      }
    else  
      {
      
      sfinfo.format=filetype;       //Seeting format of the output file.
      sfinfo.samplerate=(int)Data.fs; //Setting sampling rate
      sfinfo.channels=(int)Data.n_channels;        //Setting the number of channels

      if(!(outfile = sf_open (Data.file_name, SFM_WRITE, &sfinfo)))    /* Open the output file. */
        {   
        fl_show_messages("Not able to open output file.");
        puts (sf_strerror (NULL)) ;
        return  ;
        } 
         /* While there are.frames in the input file, read them, process
        ** them and write them to the output file.
        */
      k=0;
      for(n=0;n<Data.channels.col;n++)
	{
        for(chnl=0;chnl<sfinfo.channels;chnl++)                 //Over the channels
          {
          buffer_data[k]=Data.channels.m[chnl][n];
          k++;
          }
	if(k==BUFFER_LEN)
          {   
	  sf_write_float(outfile, buffer_data, k) ;
	  k=0;
	  }
	}
      if(k<BUFFER_LEN)
        {   
	sf_write_float(outfile, buffer_data, k) ;
	}
      sf_close (outfile);
      }
    }
  else
    {
    save_as();
    }
  }


