#include <unistd.h>
#include <errno.h>
#include <math.h>
#include <fftw3.h>

void sigsep_noptch_nounvoiced();   //Separate signals with more than 2 sensors.

//*******************************************************
//Signal separation algorithm implementation in C.
//Modified version of sigsep.c to function without using
//PITCH information in the weight decision. 
//
//*******************************************************
void sigsep_noptch_nounvoiced()
  {
  extern FL_FORM  *audio_processer;
  extern signal Data;
  extern source *SOURCE; 
  source *SOURCE_tmp;
  extern int N_SOURCE;
  char* source_display_window_label;
  int DOA_DETECTED;
  int N_pad,LENGTH,L,L_pad,L_start,L_end,L_proc,L_DOAs,N_DOA_hist_bin,l,PF_idxN[2],PF_idxN_tmp[2],PF_idxN1,PF_idxN2,N_PTCH_DOA_idx; 		//Number of sensors.
  float micspacing,c,tmpi,MAX_TMP,TMP_VAL,PTCH_DOA,POW_UNVOICED,POW_VOICED,SCALE_LR;
  int i,col,row,n,rcnt,ccnt,k,q,n_src,doa,doa_tmp=0,ptch,ptch_tmp,src,n_tmp,mic,tmp_src,src_tmp,m,n_src_tmp;   //Index variables
  matrix MEAN,TMP;
  fftw_complex *TMP1, *TMP2;                 //The signal matrix fromed from Data.channels in fftw format.
  int M=2,N_DOAS,N_DOAS_tmp,N_SOURCE_tmp,TMP_cnt,PTCH_DOA_idx[1],WEIGHT_SP_SUM[SOURCE_NUM];	//Number of mics
  int *ID_PK;
  float *DOAs, *DOA_full, *DOA_list, *DOA_list_tmp, *DOA_wt_hist, *DOA_hist_idx, *PF_idx_tmp, *DOAs_at_PF, *POW_at_PF, *PTCH_DOA_hist_idx, *PTCH_DOA_hist, *WGHT_COMM, *WGHT_TMP;
  float *SPEC1,*SPEC2;
  float **PF_idx, **WEIGHT_SP;               //The array for storing pitch frequencies
  FILE*  fid;
  cplxnum ***FB_ORIG;           //The matrix of FFTs of the signals.
  fftw_plan FPLN;		//FFTW plan for the comptation
 // fftw_complex *TMP2;
  SCALE_LR=1;           //Scaling to compensate for unequal gain in the channels (VRIABLE IMPORTANT)

  if (Data.n_channels==1)
    {
    fl_show_messages("This is a single channel data. I need two ears for now!!");
    return;
    }

  printf("Start \n");
  SOURCE=(source *)calloc(SOURCE_NUM,sizeof(source));
  SOURCE_tmp=(source *)calloc(SOURCE_NUM,sizeof(source));
  c=330; 		//Velocity of sound.
//  N_pad=4*(int)rintf(44100/Data.fs) -1 ;       	//Number of L blocks of zero padding to be done                  //VARIABLE
  micspacing=0.135/(c/Data.fs);          //Mic sapcing in terms of  wavelength at sampling frequency.  //VARIABLE here 13cm
//  micspacing=0.0825/(c/Data.fs);          //Mic sapcing in terms of  wavelength at sampling frequency.  //VARIABLE here 8.25cm
  L=(int)rintf(1024*Data.fs/44100);
  L_pad=4096-L;
//  L=(int) pow(2,(double)((int)(log((double)((512.0*Data.fs)/16000.0))/log(2))));   //VARIABLE
//  L_pad=((int)pow(2,rint(log(((double)(L*N_pad+L)))/log(2))))-L;
//  printf("Fs =%f, L=%d ,L_pad=%d N_pad=%d CHK=%d log2=%f\n",Data.fs,L,L_pad,N_pad,(int)pow(2,rint(log(((double)(L*N_pad+L)))/log(2))),log((double)2));

  //Creating the fft filterbank o/p  matrix
  FB_ORIG = (cplxnum ***) calloc(L,sizeof(cplxnum**));
  for(ccnt =0;ccnt<L;ccnt++)              //Up to length
    {
    FB_ORIG[ccnt]=(cplxnum **) calloc(M,sizeof(cplxnum*));         //Upto number of sensors
    for(rcnt = 0;rcnt<M; rcnt++)
      FB_ORIG[ccnt][rcnt] = (cplxnum *) calloc(L_pad+L,sizeof(cplxnum));       
    } 

  //Create FFTW plan for the comptation
  TMP1 = fftw_malloc(sizeof(fftw_complex) * (L+L_pad));
  TMP2 = fftw_malloc(sizeof(fftw_complex) * (L+L_pad));
  FPLN = fftw_plan_dft_1d(L+L_pad,TMP1,TMP2,FFTW_FORWARD,FFTW_ESTIMATE);
  
  //Reserving space for spectrum
  SPEC1 = (float *) calloc(L_pad+L,sizeof(float));       
  SPEC2 = (float *) calloc(L_pad+L,sizeof(float));       
  WGHT_COMM = (float *) calloc(L_pad+L,sizeof(float));       
  WGHT_TMP = (float *) calloc(L_pad+L,sizeof(float));       
  WEIGHT_SP=(float **) calloc(SOURCE_NUM,sizeof(float *));
  for(m=0;m<SOURCE_NUM;m++)
    {
    WEIGHT_SP[m]=(float *) calloc(L_pad+L,sizeof(float));
    }
  DOA_full=(float *) calloc(L_pad+L,sizeof(float));
  
  //Making zero mean
/*  TMP=reshape(Data.channels,Data.channels.col,Data.channels.row);
  MEAN=mean(TMP);          //Mean vector
  free_mtrx(&TMP);
  for (col=0;col<Data.channels.col;col++)
    {
    TMP1.val[0][col].re-=MEAN.m[0][0];
    TMP1.val[1][col].re-=MEAN.m[0][1];
    }
  free_cmtrx(&TMP1); 
  free_mtrx(&MEAN); */

  LENGTH=Data.channels.col-L;                  //Total length to be processed
  L_start= ((int)rint(8*Data.fs*(L+L_pad)/(44100*4096)))-1;        //Index of possible first pitch frequency  (VARIABLE)
  L_end= ((int)rint(46*Data.fs*(L+L_pad)/(44100*4096)))-1;          //Index of possible last pitch frequency(some more than) (VARIABLE)
//  L_proc=((int)rint(372*Data.fs*(L+L_pad)/(44100*4096)));   //Length of initial portion of spectrum used for pitch detection.
  N_DOA_hist_bin=20;                      //Number of bins used in finding histogram of DOA estimates.  (VARIABLE)
         //Initialising the SOURCE structure
  SOURCE[0].DOA_SET=0;
  SOURCE[0].PF_SET=0;
  SOURCE[0].WT=0;             //For pitch
  SOURCE[0].WTDOA=0;          //For DOA   
  N_SOURCE=0;          //Number of sources

                            //Allocating memories for DOA storage and histograms
  DOAs=(float *) calloc((int)(L+L_pad),sizeof(float));
  DOA_wt_hist=(float *) calloc(N_DOA_hist_bin,sizeof(float));
  DOA_hist_idx=(float *) calloc(N_DOA_hist_bin,sizeof(float));
         //Outer loop over time index. Most of the algo is within it.
  for(l=0;l<LENGTH;l++)
    {
    for(n=0;n<L;n++)        //Filling data in zeropadded array
      {
     // TMP1[n][0]=Data.channels[0][l+n];
      TMP1[n][0]=Data.channels.m[0][l+n]*SCALE_LR;
      TMP1[n][1]=0;
      }
    for(n=L;n<(L+L_pad);n++)        //Filling zeros in zeropadded array
      {
      TMP1[n][0]=0;
      TMP1[n][1]=0;
      }
    fftw_execute(FPLN);               //Doing the fft
    for(n=0;n<(L+L_pad);n++)       //Filling the FB_ORIG array, channel1, using fftw output
      {
      FB_ORIG[(l % L)][0][n].re=TMP2[n][0];
      FB_ORIG[(l % L)][0][n].im=TMP2[n][1];
      }

    for(n=0;n<L;n++)        //Filling data in zeropadded array
      {
      TMP1[n][0]=Data.channels.m[1][l+n];
      TMP1[n][1]=0;
      }
    for(n=L;n<(L+L_pad);n++)        //Filling zeros in zeropadded array
      {
      TMP1[n][0]=0;
      TMP1[n][1]=0;
      }
    fftw_execute(FPLN);               //Doing the fft
    for(n=0;n<(L+L_pad);n++)       //Filling the FB_ORIG array, channel2  using fftw output
      {
      FB_ORIG[(l % L)][1][n].re=TMP2[n][0];
      FB_ORIG[(l % L)][1][n].im=TMP2[n][1];
      }

    if ((l%L)==(L-1))
      {
      fl_check_forms();           //So that form remains interactive or responsive.
      POW_VOICED=0;
      POW_UNVOICED=0;
      TMP_cnt=(int)rint((double)L/2);
      for (i=0;i<(L+L_pad);i++)   //To find abs spectrum at one of the frequencies.
	{
  	SPEC1[i]=(float)sqrt((double)(FB_ORIG[TMP_cnt][0][i].re*FB_ORIG[TMP_cnt][0][i].re+FB_ORIG[TMP_cnt][0][i].im*FB_ORIG[TMP_cnt][0][i].im));
  	SPEC2[i]=(float)sqrt((double)(FB_ORIG[TMP_cnt][1][i].re*FB_ORIG[TMP_cnt][1][i].re+FB_ORIG[TMP_cnt][1][i].im*FB_ORIG[TMP_cnt][1][i].im));
	if(i<(int)rint(400*Data.fs*(L+L_pad)/(44100*4096)))                           //VARIABLE  ~ Power in voiced components
	  {
	  POW_VOICED+=SPEC1[i];
	  }
	else if(i<((L+L_pad)-(int)rint(400*Data.fs*(L+L_pad)/(44100*4096))))         //VARIABLE  ~ Power in voiced components
	  {
	  POW_UNVOICED+=SPEC1[i];
	  }
  	//SPEC[i]=(float)sqrt((double)(FB_ORIG[l%L][1][i].re*FB_ORIG[l%L][1][i].re+FB_ORIG[l%L][1][i].im*FB_ORIG[l%L][1][i].im));
	}
      DOA_estims_all(FB_ORIG, DOAs, Data.fs, micspacing,c, L+L_pad, L);     //Estimating the DOAs in the lower freq range
      L_DOAs=(int)((L+L_pad)/(2*micspacing));                        //Toatal number of sources detected.
      for(m=1;m< L_DOAs;m++)   //Initiallising the compete DOA matrix over all frequency bins.
	{
        DOA_full[m]=DOAs[m];
	DOA_full[(L+L_pad)-m]=DOAs[m];
	}
      scale_hist(DOAs,SPEC1,N_DOA_hist_bin,L_DOAs,DOA_wt_hist,DOA_hist_idx); //Scaled histogram of DOAs is in HIST_val
      ID_PK=(int *)calloc(4,sizeof(int));  //Allocating space for Index of the peaks from peak_pick_win
      MAX_TMP=DOA_wt_hist[max_vec(DOA_wt_hist,N_DOA_hist_bin)];  //Maximum of the 
      for (i=0;i<N_DOA_hist_bin;i++)
	DOA_wt_hist[i]=((DOA_wt_hist[i]>(0.3*MAX_TMP)) ? DOA_wt_hist[i]:0);
      N_DOAS=0;     //Number of distinct DOAs detected as sources.
      peak_pick_win(DOA_wt_hist,N_DOA_hist_bin,4,ID_PK,&N_DOAS); //Picking the peaks in the weight DOA histogram
      DOA_list=(float *)calloc(N_DOAS,sizeof(float));        //Allocating space to store the DOAs of sources in this block
      for(i=0;i<N_DOAS;i++)               //store the DOAs of sources in this block
        DOA_list[i]=DOA_hist_idx[ID_PK[i]];

      

      PF_idx=(float **)calloc(2,sizeof(float *));
      pitchdetect(SPEC1,SPEC2,L+L_pad,L_start,L_end,PF_idx,&PF_idxN1,&PF_idxN2);//Estimating the pitch frequency in the mics
                 //The 2x.. array PF_idx has the pitch freqs. Number of pitches in each mic is PF_idxN1 and PF_idxN2 respec.
      PF_idxN[0]=PF_idxN1;
      PF_idxN[1]=PF_idxN2;

      if((N_DOAS>=1) && (N_SOURCE==0))
        {
        SOURCE[0].DOA=DOA_list[0]; //Start a new data structure for that source.
	SOURCE[0].DOA_SET=1;         //Setting flag saying DOA has been allocated.
	N_SOURCE=1;                 //Incrementing the source count
        SOURCE[0].sig=(float *)calloc(LENGTH,sizeof(float));            //Initialize  the signal part as empty.
	SOURCE[0].L_src=0;    //Length of source signal after initialising.
	SOURCE[0].L_init=(l+1)-L;    //Length of source signal after initialising.
        SOURCE[0].PF_SET=0;             //Initialise the pitch freqency
        SOURCE[0].WT=0;              //Initialise the weighting/flag for inclusion in this cycle. Mainly to determine if PF is to be used in this block.
        SOURCE[0].WTDOA=1;           //Initialise the weighting/flag for inclusion in this cycle. Mainly to determine if DOA is to be used in this block.
        /*for(doa=0;doa<(N_DOAS-1);doa++)*/
	  /*DOA_list[doa]=DOA_list[doa+1];    //Removing this DOA from the list.*/
	/*N_DOAS-=1;*/
	}  

      //Reducing(!) the source weight (Corresponding to decay of exciataion)
      for(n_src=0;n_src<N_SOURCE;n_src++)
	{
	SOURCE[n_src].WT++;
	SOURCE[n_src].WTDOA++;
	}
       
      //Assigning Section

      //Eliminating existing clues
      if (N_SOURCE>0)
	{
        DOA_list_tmp=(float *)calloc(N_DOAS,(float)sizeof(float));  
	for(src=0;src<N_SOURCE;src++)
	  {
	  if(N_DOAS>0)
	    {
	    for(n_tmp=0;n_tmp<N_DOAS;n_tmp++)
	      {
              printf("\nDOA_list[%d]=%f\n",n_tmp,DOA_list[n_tmp]);   //For checking DOA 
              DOA_list_tmp[n_tmp]=DOA_list[n_tmp];
              }
	    N_DOAS_tmp=N_DOAS;
	    N_DOAS=0;
	    for(doa=0;doa<N_DOAS_tmp;doa++)
	      {
	      if(SOURCE[src].DOA_SET==1)
		{
		if (fabs((double)SOURCE[src].DOA-(double)DOA_list[doa])<15)
		  {
		  SOURCE[src].DOA=0.9*SOURCE[src].DOA+(1-0.9)*DOA_list[doa];    //Was originally 0.993
		  SOURCE[src].WTDOA=1;
		  //setdiff(DOA_list_tmp,DOA_list(doa)) implemented below
	/*	  doa_tmp=0;
		  for(n_tmp=0;n_tmp<N_DOAS_tmp;n_tmp++)
		    {
		    if(DOA_list_tmp[n_tmp]!=DOA_list[doa])
		      {
		      DOA_list_tmp[doa_tmp]=DOA_list[doa];
		      doa_tmp++;
	              N_DOAS=doa_tmp;
		      } 
                    }*/
		  }
		else
		  {
		  DOA_list_tmp[N_DOAS]=DOA_list[doa];
		  N_DOAS++;
		  }
		}
	      }
	    for(n_tmp=0;n_tmp<N_DOAS;n_tmp++)    //Impementing DOA_list=DOA_list_tmp;
              {
	      DOA_list[n_tmp]=DOA_list_tmp[n_tmp];
              }
	    } 
	//Eliminating pitch clues
	  for(mic=0;mic<2;mic++)
            {
	    if(PF_idxN[mic]>0)
	      {
	      PF_idx_tmp=(float *)calloc(PF_idxN[mic],sizeof(float));
	      for(n_tmp=0;n_tmp<PF_idxN[mic];n_tmp++)    //Impementing PF_idx_tmp=PF_idx{mic};
	        PF_idx_tmp[n_tmp]=PF_idx[mic][n_tmp];
	      PF_idxN_tmp[mic]= PF_idxN[mic];
	      PF_idxN[mic]=0;
	      for(ptch=0;ptch<PF_idxN_tmp[mic];ptch++)
	        {
	        if((SOURCE[src].PF_SET==1) && (SOURCE[src].WT <= 2))
	          {
	          if(fabs(PF_idx[mic][ptch]-SOURCE[src].PF)<1.5)
	            {
	            SOURCE[src].PF=PF_idx[mic][ptch];
	            SOURCE[src].PF_SET=1;
	  	    SOURCE[src].WT=1;
	  	 /*   if (N_DOAS>0)
	  	      {
		    //setdiff(PF_idx_tmp,PF_idx{mic}(ptch)) implemented below
	  	      ptch_tmp=0;
	  	      for(n_tmp=0;n_tmp<PF_idxN[mic];n_tmp++)
	  	        {
	    	        if(PF_idx_tmp[n_tmp]!=PF_idx[mic][ptch])
	                  {
	                  PF_idx_tmp[ptch_tmp]=PF_idx[mic][ptch];
	                  ptch_tmp++;
			  PF_idxN[mic]=ptch_tmp;
	                  }
                        } 
	              }*/
	            }
		  /*else if(N_DOAS>0)*/
		  else
		    {
		    PF_idx_tmp[PF_idxN[mic]]=PF_idx[mic][ptch];
		    PF_idxN[mic]++;
		    }
	          }
	        else
		  {
		  PF_idx_tmp[PF_idxN[mic]]=PF_idx[mic][ptch];
		  PF_idxN[mic]++;
		  }
	        } 
	      for(n_tmp=0;n_tmp<PF_idxN[mic];n_tmp++)    //Impementing PF_idx{mic}=PF_idx_tmp;;
	        PF_idx[mic][n_tmp]=PF_idx_tmp[n_tmp];
	      free(PF_idx_tmp);
	      PF_idx_tmp=NULL;
	      }
	    }
	  }
        free(DOA_list_tmp);
        DOA_list_tmp=NULL;
	}
         //Updating the source DOAs and recognising new sources using DOA.
/*      if ((SOURCE[0].DOA_SET==0)&&(N_DOAS>=1))
        {
        SOURCE[0].DOA=DOA_list[0]; //Start a new data structure for that source.
	SOURCE[0].DOA_SET=1;         //Setting flag saying DOA has been allocated.
	N_SOURCE=1;                 //Incrementing the source count
        SOURCE[0].sig=(float *)calloc(LENGTH,sizeof(float));            //Initialize  the signal part as empty.
	SOURCE[0].L_src=0;    //Length of source signal after initialising.
	SOURCE[0].L_init=(l+1)-L;    //Length of source signal after initialising.
        SOURCE[0].PF_SET=0;             //Initialise the pitch freqency
        SOURCE[0].WT=0;              //Initialise the weighting/flag for inclusion in this cycle. Mainly to determine if PF is to be used in this block.
        SOURCE[0].WTDOA=1;           //Initialise the weighting/flag for inclusion in this cycle. Mainly to determine if PF is to be used in this block.
	}   */
      for(doa=0;doa<N_DOAS;doa++)   //Over present estimated list
	{
	if(N_SOURCE<8)
	  {
          SOURCE[N_SOURCE].DOA=DOA_list[doa];   //Start a new data structure for that source.
	  SOURCE[N_SOURCE].DOA_SET=1;
          SOURCE[N_SOURCE].sig=(float *)calloc(LENGTH,sizeof(float));                //Initialize  the signal part as empty.
	  SOURCE[N_SOURCE].L_src=0;             //Length of source signal after initialising.
	  SOURCE[N_SOURCE].L_init=(l+1)-L;    //Length of source signal after initialising.
          SOURCE[N_SOURCE].PF_SET=0;                 //Set PF_SET to 0 saying that PF has not been set
          SOURCE[N_SOURCE].WT=0;                //Initialise the weighting/flag for inclusion in this cycle. Mainly to determine if PF is to be used in this block.
          SOURCE[N_SOURCE].WTDOA=1;            // Initialise the weighting/flag for inclusion in this cycle. Mainly to determine if PF is to be used in this block.
	  N_SOURCE++;				//Incrementing source count
	  }
	}
      DOAs_at_PF=(float *)calloc((int)floorf((float)L_DOAs/(float)L_start),sizeof(float));    //Allocating space for temporary array DOAs_at_PF
      POW_at_PF=(float *)calloc((int)floorf((float)L_DOAs/(float)L_start),sizeof(float));     //Allocating space for temporary array POW_at_PF
      /*DOAs_at_PF=(float *)calloc(N_DOAS,sizeof(float));    //Allocating space for temporary array DOAs_at_PF*/
      PTCH_DOA_hist=(float *)calloc(20,sizeof(float));     //Allocating space for PTCH_DOA_hist
      PTCH_DOA_hist_idx=(float *)calloc(20,sizeof(float)); //Allocating space for PTCH_DOA_hist_idx
      //PITCH PART
      for(mic=0;mic<2;mic++)                     //Over the mics
	{
	for(ptch=0;ptch<PF_idxN[mic];ptch++)     //Over the pitches of the mic
	  {
  //Doing sum(setdiff(DOAs(round(PF_idx{mic_n}(ptch) * (1:floor(length(DOAs)/PF_idx{mic_n}(ptch))))),0)>0) > (0.5* length((1:floor(length(DOAs)/PF_idx{mic_n}(ptch)))
	  TMP_cnt=0;
	  for(doa=0;doa<(int)floorf((float)L_DOAs/PF_idx[mic][ptch]);doa++)
	    {
	    TMP_VAL=DOAs[(int)rint(PF_idx[mic][ptch]*(float)doa)];
	    if((TMP_VAL>0) && (TMP_VAL<180)) 
	      {
	      DOAs_at_PF[TMP_cnt]=TMP_VAL;
	      POW_at_PF[TMP_cnt]= (mic==0) ? SPEC1[(int)rint(PF_idx[mic][ptch]*(float)doa)] : SPEC2[(int)rint(PF_idx[mic][ptch]*(float)doa)];
	      TMP_cnt++;
	      }
	    }
	  if(TMP_cnt>(0.25*L_DOAs/PF_idx[mic][ptch]))   //I have changed this from 0.5 in the original to 0.25    (VARIABLE)
	    {
	    /*printf("(0.5*L_DOAs/PF_idx[mic][ptch])= %f  TMP_cnt=%d \n",(0.5*L_DOAs/PF_idx[mic][ptch]),TMP_cnt);*/
	    /*mhist(DOAs_at_PF,20,TMP_cnt,PTCH_DOA_hist,PTCH_DOA_hist_idx);  //Finding hist of DOAs at this pitch  (VARIABLE)*/
            scale_hist(DOAs_at_PF,POW_at_PF,20,TMP_cnt,PTCH_DOA_hist,PTCH_DOA_hist_idx); //Scaled histogram of DOAs is in HIST_val
            peak_pick_win(PTCH_DOA_hist,20,1,PTCH_DOA_idx,&N_PTCH_DOA_idx); //Finding the DOA of this pitch, intermediate step
            PTCH_DOA=PTCH_DOA_hist_idx[(int)PTCH_DOA_idx[0]];                  //Finding the DOA of this pitch
	    for(tmp_src=0;tmp_src<N_SOURCE;tmp_src++)
	      {
              if(fabsf(SOURCE[tmp_src].DOA-PTCH_DOA)<15)              //VARIABLE
		{ 
		if((SOURCE[tmp_src].PF_SET==0)  || (SOURCE[tmp_src].WT>=3) || (fabsf(SOURCE[tmp_src].DOA-PTCH_DOA)<5))   //VARIABLE
		  {
		  SOURCE[tmp_src].PF=PF_idx[mic][ptch];                    //Assign the source that pitch
		  SOURCE[tmp_src].PF_SET=1;                    //Assign the source that pitch
		  SOURCE[tmp_src].WT=1;
		  }
		}
	      }
	    }
	  }
	}
      //Removing reduntant sources.
      N_SOURCE_tmp=N_SOURCE;
      N_SOURCE=0;
           //If the souces look too similar 
    /*  for(src=0;src<N_SOURCE_tmp-1;src++)
	{
        for(m=src+1;m<N_SOURCE_tmp;m++)
	  {
	  if ((SOURCE[src].WT!=0) && (SOURCE[m].WT!=0))
	  if((fabsf(SOURCE[src].DOA-SOURCE[m].DOA)<15)&&((fabsf(SOURCE[src].PF-SOURCE[m].PF)<1.5))&&(SOURCE[src].WT<=2)&&(SOURCE[m].WT<=2) && (SOURCE[m].L_src < L*40))   //(VARIABLE)
	    {
	    SOURCE[src].DOA=(SOURCE[src].DOA+SOURCE[m].DOA)/2;
	    SOURCE[src].PF=(SOURCE[src].PF+SOURCE[m].PF)/2;
	    SOURCE[m].L_src=0;
	    SOURCE[m].WT=10;                //seting to 10 (large).
	    SOURCE[m].WTDOA=10;            // seting to 10 (large).
	    }
	  }
	} */

	
      for(src=0;src<N_SOURCE_tmp;src++)
	{
        if (((SOURCE[src].WT<6)&(SOURCE[src].WTDOA<5)) || (SOURCE[src].L_src > (L*6)))  //If recently active or relatively old, keep the source (VARIABLE)
	  {
          SOURCE_tmp[N_SOURCE]=SOURCE[src];
          N_SOURCE++;

       	  SOURCE[src].DOA_SET=0;
	  SOURCE[src].L_src=0;             //Length of source signal after initialising.
	  SOURCE[src].L_init=0;    //Length of source signal after initialising.
          SOURCE[src].PF_SET=0;                 //Set PF_SET to 0 saying that PF has not been set
          SOURCE[src].WT=0;                //Reseting to 0.
          SOURCE[src].WTDOA=0;            // Reseting to 0.
	  }
	else          //Else free the source
	  {
	  free(SOURCE[src].sig);
	  SOURCE[src].sig=NULL;

	  SOURCE[src].DOA_SET=0;
	  SOURCE[src].L_src=0;             //Length of source signal after initialising.
	  SOURCE[src].L_init=0;    //Length of source signal after initialising.
          SOURCE[src].PF_SET=0;                 //Set PF_SET to 0 saying that PF has not been set
          SOURCE[src].WT=0;                //Reseting to 0.
          SOURCE[src].WTDOA=0;            // Reseting to 0.
	  }
	}
      for(src=0;src<N_SOURCE;src++)       //Implementing SOURCE=SOURCE_tmp;
	{
        SOURCE[src]=SOURCE_tmp[src];
        }
      
        //RECOVERY PART
      for(m=0;m< (L+L_pad);m++)   //Initiallising weights for common frequencies.
	{
        WGHT_COMM[m]=1;
	}
      for(q=0;q<N_SOURCE;q++)   //Over sources
	{
	  //Implementing  WEIGHT_SP(q,:)=(abs(DOA_full-SOURCE{q}.DOA)<10); 
	WEIGHT_SP_SUM[q]=0;    //For summing weights
	for(m=0;m<(L+L_pad);m++)
	  WEIGHT_SP[q][m]=0;
	for (m=1;m<(L_DOAs);m++)
	  {
          WEIGHT_SP[q][m]=(fabsf(DOA_full[m]-SOURCE[q].DOA)<10) ? 1:0;        //Weighting for sources spectrum using DOA information. (VARIABLE)
	  WEIGHT_SP[q][m-1]=(WEIGHT_SP[q][m]==1) ? 1:0;         //For WEIGHT_SP(q,:)= (WEIGHT_SP(q,:)+[WEIGHT_SP(q,2:end) 0]+[0 WEIGHT_SP(q,1:end-1)])>0;   To create a window around the set frequency point
	  WEIGHT_SP[q][m+1]=((WEIGHT_SP[q][m]==1) && (WEIGHT_SP[q][m+1]==0)) ? 2:WEIGHT_SP[q][m+1]; // ''
	  }       //To create a window around the set frequency point
	for (m=1;m<(L_DOAs)-1;m++) //For WEIGHT_SP(q,:)= (WEIGHT_SP(q,:)+[WEIGHT_SP(q,2:end) 0]+[0 WEIGHT_SP(q,1:end-1)])>0;
	  {
	  WEIGHT_SP[q][m]=(WEIGHT_SP[q][m]==2) ? 1:WEIGHT_SP[q][m];
	  WEIGHT_SP[q][(L+L_pad-1)-m]=WEIGHT_SP[q][m];
	  if(WEIGHT_SP[q][m]>0)
	    {
            WEIGHT_SP_SUM[q]+=2;
	    }
	  }
	
        } 
              //Weighting using pitch info

      for(q=0;q<N_SOURCE;q++)   //Over sources
	{
        for(m=0;m< (L+L_pad);m++)   //Initiallising weights for using pitch info. Implementing WGHT_TMP=zeros(size(DOA_full));
          {
          WGHT_TMP[m]=0;
          }
    /*    if((SOURCE[q].PF_SET==1)&&(SOURCE[q].WT==1))       //Checking if pitch and source are detected.
          {
          for(m=1;m<(int)floorf((L+L_pad)/(2*SOURCE[q].PF));m++) //Weighting at harmonics of pitchfrequency
            {
            i=(int)rintf((float)m*SOURCE[q].PF);
	    //printf("400 is %d\n",(int)rint(400*Data.fs*(L+L_pad)/(44100*4096)));
            if (i<(int)rint(400*Data.fs*(L+L_pad)/(44100*4096)))      //VARIABLE
              {
              DOA_DETECTED=0;
              for (n_src_tmp=0;n_src_tmp<N_SOURCE;n_src_tmp++) //At pitch frequencies and if there are no weight set in other sources by DOA. 
                DOA_DETECTED+=WEIGHT_SP[n_src_tmp][m];
              if (DOA_DETECTED==0)         //Then weight the points for detected pitch
                {
                WGHT_TMP[i]=1;
                WGHT_TMP[i-1]=(WGHT_TMP[i]==1) ? 1:0;  //For
                WGHT_TMP[i+1]=((WGHT_TMP[i]==1) && (WGHT_TMP[i+1]==0)) ? 2:WGHT_TMP[i+1]; // ''
                }
              }
            }
          for (m=1;m<(int)floorf((L+L_pad)/(2*SOURCE[q].PF));m++) //For "
            {
            i=(int)rintf((float)m*SOURCE[q].PF);
            if(i<(int)rint(400*Data.fs*(L+L_pad)/(44100*4096)))                                          //VARIABLE
              {
              WGHT_TMP[i]=(WGHT_TMP[i]==2) ? 1:WGHT_TMP[i];
              }
            }
          } */          

        
/*        if(((SOURCE[q].WT==2) && SOURCE[q].PF_SET) && ((POW_UNVOICED>(int)rint(4000*Data.fs*(L+L_pad)/(44100*4096))) || (POW_UNVOICED>POW_VOICED)))  //VARIABLE 
          {
          if(WEIGHT_SP_SUM[q]<20)    //VARIABLE  If mostly unvoiced removed the few detected frequencies in the voiced region.
            {
	    WEIGHT_SP[q][0]=0;
            for(m=1;m<(int)rint(500*Data.fs*(L+L_pad)/(44100*4096));m++)           //VARIABLE
	      {
	      WEIGHT_SP[q][m]=0;       
	      WEIGHT_SP[q][((L+L_pad)-m)]=0;
	      }
            }
	      // Associate the unvoiced part to this source q
          for(m=399;m<((L+L_pad)/2);m++)           //VARIABLE  corrected to (L+L_pad)/2 because WGHT_TMP filled full before, and symmetrising done later
	    {
	    WGHT_TMP[m]=1;                                //Unvoiced.
	    }
	  SOURCE[q].WT=1;               //Reset the WT to 1 since source is active.
	  SOURCE[q].WTDOA=1;            //Reset the WTDOA to 1 since source is active.
          } */
        for(m=0;m<=(L+L_pad)/2;m++)           // Corrected
	  {
	  WGHT_TMP[(L+L_pad-1)-m]=WGHT_TMP[m];  //Symmetrising;   WGHT_TMP=WGHT_TMP+[0 fliplr(WGHT_TMP(2:end))]; 
	  WEIGHT_SP[q][m]= ((WEIGHT_SP[q][m]==1) || (WGHT_TMP[m]==1)) ? 1:0;        //Updating the weighting for qth source using pitch info
          WEIGHT_SP[q][(L+L_pad-1)-m]=WEIGHT_SP[q][m];          //Updating the weighting for qth source using pitch info
	  WGHT_COMM[m]-=WEIGHT_SP[q][m]*WEIGHT_SP[q][m];
	  WGHT_COMM[(L+L_pad-1)-m]=WGHT_COMM[m];
	  }
        }


        //Making zero all freqs beyond  a certain frequency conditions,
      for(m=(L_DOAs+(int)rint(400*Data.fs*(L+L_pad)/(44100*4096)));m<=(L+L_pad)/2;m++)           //VARIABLE
	{
        WGHT_COMM[m]=0;
	WGHT_COMM[(L+L_pad-1)-m]=0;
	}
       //Recovering from the output of the filterbank
      for(q=0;q<N_SOURCE;q++)
	{
	SOURCE[q].L_src+=L;
        for(i=1;i<=(L+L_pad/2);i++)
	  {
	  if(WEIGHT_SP[q][i]>0)
	    {
	    for(m=0;m<L;m++)
	      {
              if(SOURCE[q].DOA<80)       // Added on 6-10
                SOURCE[q].sig[(l+1-L)+m]+=2*FB_ORIG[m][1][i].re/(L+L_pad);
              else                       // Added on 6-10
              if(SOURCE[q].DOA>100)      // Added on 6-10
                SOURCE[q].sig[(l+1-L)+m]+=2*FB_ORIG[m][0][i].re/(L+L_pad); // Added on 6-10
              else                                                         // Added on 6-10
                SOURCE[q].sig[(l+1-L)+m]+=(FB_ORIG[m][1][i].re/(L+L_pad)+FB_ORIG[m][0][i].re/(L+L_pad)); // Added on 6-10
	      }
	    }
	  }
	}
      printf("l=%d\n",l);
      free(DOAs_at_PF);
      free(POW_at_PF);
      DOAs_at_PF=NULL;
      POW_at_PF=NULL;
      free(PF_idx[0]);
      free(PF_idx[1]);
      free(PF_idx);
      PF_idx=NULL;
      free(DOA_list);
      DOA_list=NULL;
      free(ID_PK);
      ID_PK=NULL;
      }
    }
  
   //Freeing FB_ORIG 
  for(ccnt =0;ccnt<L;ccnt++)
    {
    for(rcnt = 0;rcnt<M; rcnt++)
      free(FB_ORIG[ccnt][rcnt]);       
    free(FB_ORIG[ccnt]);
    }
  for(m=0;m<SOURCE_NUM;m++)
    {
    free(WEIGHT_SP[m]);
    }
  free(WEIGHT_SP);
  free(SPEC1);
  SPEC1=NULL;
  free(SPEC2);
  SPEC2=NULL;
  free(WGHT_COMM);
  WGHT_COMM=NULL;
  free(WGHT_TMP);
  WGHT_TMP=NULL;
  free(DOA_full);
  DOA_full=NULL;
  free(FB_ORIG); 
  FB_ORIG=NULL; 
  free(DOAs); 
  DOAs=NULL;
  free(DOA_wt_hist);
  DOA_wt_hist=NULL;
  free(DOA_hist_idx);
  DOA_hist_idx=NULL;
  fftw_destroy_plan(FPLN); 
  fftw_free(TMP1); fftw_free(TMP2);        //Clearing temporary arrays used by fftw
  source_display_window_label=(char *)calloc(300,sizeof(char));
  sprintf(source_display_window_label,"source diaply (sigsep_noptch_nounvo.) on ");
  source_display_window_label=strcat(source_display_window_label,Data.file_name); //Creating new window label
  m=source_plot_init(source_display_window_label);                    //Calling function to plot the separated sources.
  /*source_plot();*/
  }

